<?php
//
$auth_database = 'afwg_hub_users';
$auth_table = $auth_database.'.dbUsers';
$main_database = 'afwg_hub';
$meta_database = 'afwg_hub_meta_data';
$misc_database = 'afwg_hub_misc';
$prod_database = 'afwg_prod_data';
//
$main_username = 'afwg_hubUser';
$main_password = 'Sn5XCbREkhhGVfvCIY0CskNkX4V7evY7';
//
$mod_username = 'afwg_hubUpdate';
$mod_password = 'Zo4retuveOPNjfGq0kZVY7ygiQpyDwel';
//
$auth_username = 'afwg_hubLogin';
$auth_password = '5TWay21K3WDwaN2hqY8mOGWiqUEQR3T9';
//
//
// connects to the database and sets error mode
function connect_db($database=null, $username=null, $password=null) {
    //
    $server = 'localhost';
    if (is_null($database)) {
        $database = $GLOBALS['main_database'];
    }
    if (is_null($username)) {
        $username = $GLOBALS['main_username'];
    }
    if (is_null($password)) {
        $password = $GLOBALS['main_password'];
    }
    //
    // Connects to the database using the credentials stored in the variables
    $conn = new PDO("mysql:host={$server};dbname={$database}", $username, $password);
    //
    // set the PDO error mode to exception to display and handle any errors
    $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
    $conn->setAttribute(PDO::ATTR_EMULATE_PREPARES, false);
    //
    return $conn;
}
//
// only accesses the authorization table specifically
function access_auth_table($username) {
    //
    global $auth_database, $auth_username, $auth_password, $auth_table;
    $sql = "SELECT * FROM {$auth_table} WHERE `username` LIKE ?";
    //
    try {
        // connecting to the database
        $conn = connect_db($auth_database, $auth_username, $auth_password);
        //
        // preparing and executing statement
        $stmt = $conn->prepare($sql);
        $stmt->execute([$username]);
        $stmt->setFetchMode(PDO::FETCH_ASSOC);
        //
        $results =  $stmt->fetchAll();
        $results = isset($results[0]) ? $results[0] : null;
        //
        // terminating database connection
        $conn = null;
        //
        return $results;
    }
    catch(PDOException $e) {
        // Returns the PDO error encountered and displays it
        $msg = addslashes($e->getMessage());
        echo "<script>alert('{$msg}');</script>";
    }
}
//
// validates the users login credentials
function authorize_user($username, $password) {
    //
    $user_data = access_auth_table($username);
    $failed = "<script>document.getElementById('failed_login').submit();</script>";
    //
    if ($user_data === null) {
        echo $failed;
        die();
    }
    //
    if ($user_data['dbuser_status'] !== 'active') {
        echo $failed;
        die();
    }
    //
    if (!password_verify($password, $user_data['hashword'])) {
        echo $failed;
        die();
    }
    unset($user_data['hashword']);
    //
    // setting up permission pattern
    $perm_arr = preg_split('/,/', $user_data['permissions']);
    for ($i = 0; $i < count($perm_arr); $i++) {
        $perm_arr[$i] = preg_split('/[.]/',$perm_arr[$i]);
        if (count($perm_arr[$i]) > 1) {
            array_push($perm_arr,$perm_arr[$i][0]);
        }
        $perm_arr[$i] = implode('.',$perm_arr[$i]);
        $perm_arr[$i] = "(^{$perm_arr[$i]}$)";
    }
    $user_data['user_perm_pattern'] = '/(^home_page.*$)|'.implode('|',$perm_arr).'/';
    //
    // storing non-sensitive user data
    foreach ($user_data as $key => $value) {
        $_SESSION[$key] = $value;
        echo "<script>window.sessionStorage['{$key}'] = '{$value}'</script>";
    }
}
//
// passes sql args to the public function
function _fetch_auth_table_data($data_where) {
    //
    global $auth_database, $auth_username, $auth_password, $auth_table;
    $table = explode('.', $auth_table)[1];
    $conn = connect_db($auth_database, $auth_username, $auth_password);
    //
    // fetching meta_data to use in data query
    $cols_sql_args = [
        'cmd' => 'SELECT',
        'table' => 'table_meta_data',
        'where' => [
            ['in_tables', 'REGEXP', "(^|%){$table}(%|$)"]
        ],
        'order_by' => [['order_index', 'ASC']]
    ];
    //
    $meta_sql_args = [
        'cmd' => 'SELECT',
        'table' => 'table_meta_data',
        'where' => [
            ['in_tables', 'REGEXP', "(^|%){$table}(%|$)"],
            ['use_on_pages', 'REGEXP', 'mod_dbuser'],
            ['use_in_html_tables', 'REGEXP', 'dbuser_table']
        ],
        'order_by' => [['order_index', 'ASC']]
    ];
    //
    $data_sql_args = [
        'cmd' => 'SELECT',
        'cols' => [],
        'table' => $table,
        'where' => $data_where,
        'order_by' => [
            ['dbuser_first_name', 'ASC'],
            ['dbuser_last_name', 'ASC']
        ]
    ];
    //
    return ['cols_sql_args' => $cols_sql_args,
            'meta_sql_args' => $meta_sql_args,
            'data_sql_args' => $data_sql_args,
            'connection' => $conn];
}
//
// handles updating the auth table
function _update_auth_table($form_values) {
    //
    global $auth_database, $auth_username, $auth_password, $auth_table;
    $conn = connect_db($auth_database, $auth_username, $auth_password);
    //
    // initializing sql args
    $sql_args = [
        'cmd' => 'INSERT',
        'cols' => [],
        'vals' => [],
        'table' => $auth_table,
    ];
    //
    // setting password if available
    if (isset($form_values['password'])) {
        $hash = password_hash($form_values['password'], PASSWORD_DEFAULT);
        array_push($sql_args['cols'], 'hashword');
        array_push($sql_args['vals'], $hash);
        unset($form_values['password']);
    }
    //
    // setting the command and where paramter if updating an entry
    if (isset($form_values['dbuser_internal_id'])) {
        $sql_args['cmd'] = 'UPDATE';
        $sql_args['where'] = [
            ['dbuser_internal_id', 'LIKE', $form_values['dbuser_internal_id']]
        ];
        unset($form_values['dbuser_internal_id']);
    }
    //
    // adding the rest of the columns and values to sql_args
    foreach ($form_values as $col => $value) {
        array_push($sql_args['cols'], $col);
        array_push($sql_args['vals'], $value);
    }
    //
    return [$sql_args, $conn];
}
?>
