/*eslint-disable camelcase */
/*eslint-disable no-alert */
/*eslint-disable no-use-before-define */
/*eslint-disable global-strict */
////////////////////////////////////////////////////////////////////////////////
//////////////       This file holds the functions that are only     ///////////
//////////////       associated with employee data reporting         ///////////
////////////////////////////////////////////////////////////////////////////////
'use strict';
var AFW_HUB = AFW_HUB || {};
//
// generates the report page
function employee_report_page() {
    var input_div = document.getElementById('input-div'),
        emp_table_fun = report_emp_table.bind(
            null,
            1,
            'emp_last_name',
            'ASC',
            false
        ),
        data_cols_fun = report_column_selection.bind(null, false, true),
        update_fun = show_update_button.bind(
            null,
            'create-report',
            'report-table',
            'Show Changes'
        ),
        add_class = AFW_HUB.Utilities.add_class,
        remove_class = AFW_HUB.Utilities.remove_class,
        create_report_fun = create_production_report.bind(
            null,
            null,
            undefined,
            undefined
        ),
        fieldset = document.createElementWithAttr('FIELDSET', {
            id: 'data-parameters'
        }),
        elements = [
            { elm: 'LEGEND', textNode: 'Report Data Parameters' },
            { elm: 'label', class: 'label', textNode: 'Department' },
            {
                elm: 'select',
                id: 'department',
                name: 'department',
                events: [
                    { event: 'change', function: populate_preset_dropbox },
                    { event: 'change', function: emp_table_fun },
                    { event: 'change', function: data_cols_fun },
                    { event: 'change', function: update_fun },
                    {
                        event: 'change',
                        function: function() {
                            add_class('hidden-elm', 'create-report');
                            remove_class('hidden-elm', 'create-report-all');
                        }
                    }
                ]
            },
            { elm: 'div', id: 'time-range-inputs' }
        ],
        psort_opts = [
            { elm: 'option', value: 'emp_id', textNode: 'Employee ID' },
            { elm: 'option', value: 'date', textNode: 'Date' },
            { elm: 'option', value: 'emp_last_name', textNode: 'Employee Name' }
        ],
        sort_dir_opts = [
            { elm: 'option', value: 'ASC', textNode: 'Ascending' },
            { elm: 'option', value: 'DESC', textNode: 'Descending' }
        ],
        time_range_args,
        dropbox_args;
    //
    //
    AFW_HUB.Utilities.add_class('hidden-elm', 'nav-container');
    AFW_HUB.Utilities.add_class('hidden-elm', 'table-div');
    document.getElementById('page-header').textContent = 'Employee Reporting';
    //
    // setting up the data params fieldset
    fieldset.add_children(elements);
    input_div.appendChild(fieldset);
    input_div.appendChild(document.createElement('BR'));
    //
    // structure params fieldset
    fieldset = fieldset.cloneNode();
    fieldset.id = 'structure-parameters';
    elements = [
        { elm: 'LEGEND', textNode: 'Report Structure Parameters' },
        { elm: 'label', class: 'label', textNode: 'Report Type:' },
        { elm: 'br' },
        // report type checkboxes
        { elm: 'label', style: { display: 'inline' }, textNode: 'Summary:' },
        {
            elm: 'input',
            type: 'checkbox',
            id: 'report-type-summary',
            name: 'report-type-summary',
            value: '',
            style: { marginRight: '1em' },
            events: [
                {
                    event: 'click',
                    function: function() {
                        AFW_HUB.FormUtil.toggle_checkbox_value(this, 'summary', '');
                    }
                },
                { event: 'click', function: update_fun }
            ]
        },
        { elm: 'label', style: { display: 'inline' }, textNode: 'No Totals:' },
        {
            elm: 'input',
            type: 'checkbox',
            id: 'report-type-no_totals',
            name: 'report-type-no_totals',
            value: '',
            style: { marginRight: '1em' },
            events: [
                {
                    event: 'click',
                    function: function() {
                        AFW_HUB.FormUtil.toggle_checkbox_value(
                            this,
                            'no_totals',
                            ''
                        );
                    }
                },
                { event: 'click', function: update_fun }
            ]
        },
        { elm: 'label', style: { display: 'inline' }, textNode: 'No Sections:' },
        {
            elm: 'input',
            type: 'checkbox',
            id: 'report-type-no_sect_heads',
            name: 'report-type-no_sect_heads',
            value: '',
            events: [
                {
                    event: 'click',
                    function: function() {
                        AFW_HUB.FormUtil.toggle_checkbox_value(
                            this,
                            'no_sect_heads',
                            ''
                        );
                    }
                },
                { event: 'click', function: update_fun }
            ]
        },
        { elm: 'br' },
        { elm: 'br' },
        // preset select
        { elm: 'label', class: 'label', textNode: 'Preset Report:' },
        {
            elm: 'select',
            id: 'preset-report',
            name: 'preset-report',
            events: [
                { event: 'change', function: data_cols_fun },
                { event: 'change', function: update_fun }
            ]
        },
        { elm: 'br' },
        { elm: 'br' },
        // sorting boxes
        { elm: 'label', class: 'label', textNode: 'Report Sections:' },
        {
            elm: 'select',
            name: 'report-section-column',
            children: psort_opts,
            events: [{ event: 'change', function: update_fun }]
        },
        {
            elm: 'label',
            style: { display: 'inline', marginLeft: '1em' },
            textNode: 'Sort Direction:'
        },
        {
            elm: 'select',
            name: 'section-sort-dir',
            children: sort_dir_opts,
            events: [{ event: 'change', function: update_fun }]
        }
    ];
    fieldset.add_children(elements);
    input_div.appendChild(fieldset);
    //
    // adding buttons and column selection div
    elements = [
        {
            elm: 'button',
            id: 'toggle-column-selection',
            textNode: 'Show Column Selection',
            events: [
                {
                    event: 'click',
                    function: report_column_selection.bind(null, true, true)
                }
            ]
        },
        {
            elm: 'button',
            id: 'show-employee-table',
            textNode: 'Show Employee Table',
            events: [
                {
                    event: 'click',
                    function: report_emp_table.bind(
                        null,
                        1,
                        'emp_last_name',
                        'ASC',
                        true
                    )
                }
            ]
        },
        {
            elm: 'button',
            id: 'create-report',
            textNode: 'Get All Employee Data',
            events: [{ event: 'click', function: create_report_fun }]
        },
        {
            elm: 'button',
            id: 'create-report-all',
            textNode: 'Get All Employee Data',
            class: 'hidden-elm',
            events: [
                { event: 'click', function: create_report_fun },
                {
                    event: 'click',
                    function: add_class.bind(null, 'hidden-elm', 'create-report-all')
                }
            ]
        },
        {
            elm: 'button',
            id: 'print-report',
            textNode: 'Print Report',
            class: 'hidden-elm',
            events: [{ event: 'click', function: window.print.bind(window) }]
        },
        { elm: 'div', id: 'col-select-div', class: 'hidden-elm' }
    ];
    input_div.add_children(elements);
    //
    elements = [
        { elm: 'br' },
        {
            elm: 'button',
            id: 'restore-defaults',
            class: 'hidden-elm',
            textNode: 'Restore Defaults',
            events: [
                {
                    event: 'click',
                    function: function() {
                        report_column_selection(false, true);
                        show_update_button(
                            'create-report',
                            'report-table',
                            'Apply Changes'
                        );
                        add_class('hidden-elm', 'restore-defaults');
                    }
                }
            ]
        },
        { elm: 'br' }
    ];
    document.getElementById('col-select-div').add_children(elements);
    //
    // adding the time range inputs
    time_range_args = { output_id: 'time-range-inputs', update_fun: update_fun };
    create_time_range_inputs(time_range_args);
    //
    // populating dropboxes
    dropbox_args = {
        dropbox_id: 'department',
        text_format: '%department_name%',
        value_format: '%department%',
        database: 'misc_database',
        sql_args: {
            table: 'departments',
            cols: ['department', 'department_name'],
            where: [['department_type', 'REGEXP', '(^|%)employees(%|$)']],
            order_by: [['department_name', 'ASC']]
        },
        add_callback: function() {
            populate_preset_dropbox();
            report_column_selection.call(null, false, true);
        }
    };
    AFW_HUB.FormUtil.populate_dropbox_options(dropbox_args);
}
//
// populates preset dropbox
function populate_preset_dropbox() {
    var department = document.getElementById('department').value,
        html_table = department + '_report',
        dropbox_args = {
            dropbox_id: 'preset-report',
            text_format: '%preset_name%',
            value_format: '%internal_id%',
            placeholder: 'None',
            placeholder_value: '0',
            placeholder_disabled: false,
            database: 'meta_database',
            sql_args: {
                table: 'table_preset_sql_args',
                cols: ['internal_id', 'preset_name'],
                where: [['html_table', 'LIKE', html_table]]
            }
        };
    //
    AFW_HUB.FormUtil.populate_dropbox_options(dropbox_args);
}
//
/////////////////////////// Report Helper Tables //////////////////////////////
//
// generic function to create an employee table
function report_emp_table(page, sort_col, sort_dir, toggle) {
    //
    // creating argument objects
    var table_args,
        department = document.getElementById('department').value,
        report_func = create_production_report;
    //
    table_args = {
        table_name: 'employee_table',
        data_sql_args: {
            where: [
                ['department', 'REGEXP', department],
                ['emp_status', 'LIKE', 'active']
            ],
            order_by: [[sort_col, sort_dir]]
        },
        table_output_id: 'table-div',
        table_attr: { id: 'employee-table' },
        row_id_prefix: 'emp-row-',
        row_onclick: [
            { func: report_func, args: ['%emp_id%', undefined, undefined] },
            {
                func: AFW_HUB.Utilities.remove_class,
                args: ['hidden-elm', 'create-report-all']
            }
        ],
        head_row_args: {
            sort_col: sort_col,
            sort_dir: sort_dir,
            sort_onclick: [
                {
                    func: report_emp_table,
                    args: [1, '%column_name%', '%sort_dir%', false]
                }
            ]
        },
        page_nav_args: {
            curr_page: page,
            sort_col: sort_col,
            sort_dir: sort_dir,
            tot_pages_shown: 9,
            num_per_page: 10,
            page_nav_div_attr: { id: 'emp-table-page-nav' },
            id_prefix: 'emp',
            link_onclick: [
                {
                    func: report_emp_table,
                    args: ['%page%', sort_col, sort_dir, false]
                }
            ]
        }
    };
    //
    AFW_HUB.TableUtil.create_standard_table(table_args);
    if (toggle === true) {
        toggle_view_element_button(
            'show-employee-table',
            'table-div',
            'Hide Employee Table',
            'Show Employee Table'
        );
        if (document.getElementById('table-div').className.match('hidden-elm')) {
            AFW_HUB.Utilities.remove_class('hidden-elm', 'create-report-all');
        } else {
            AFW_HUB.Utilities.add_class('hidden-elm', 'create-report');
        }
    }
}
//
// creates the column selection table for the employee report
function report_column_selection(toggle, reset) {
    var container = document.getElementById('col-select-div'),
        button = document.getElementById('toggle-column-selection'),
        department = document.getElementById('department').value,
        preset = document.getElementById('preset-report').value || '0',
        hide_str = 'Hide Column Selection',
        show_str = 'Show Column Selection',
        table_args,
        add_event_handlers,
        callback;
    //
    // toggling table viewability
    if (!toggle) {
        button.value = 'update-button';
    }
    toggle_view_element_button(button, container, hide_str, show_str);
    //
    // resetting table based on preset data
    if (!reset) {
        return;
    }
    //
    add_event_handlers = function(elm) {
        var event = elm.primaryEventString(),
            func;
        //
        if (!event) {
            return;
        }
        func = function() {
            AFW_HUB.Utilities.remove_class('hidden-elm', 'restore-defaults');
            show_update_button('create-report', 'report-table', 'Show Changes');
        };
        elm.addEventListener(event, func);
    };
    table_args = {
        table_name: department + '_report',
        table_attr: { id: 'report-column-selection' },
        table_output_id: container.id,
        create_sort_row: true,
        add_event_handlers: add_event_handlers,
        add_callback: add_total_selection_row
    };
    //
    callback = function(preset_data) {
        table_args.selected_cols = preset_data.cols || ['*'];
        AFW_HUB.TableUtil.create_column_selection_table(table_args);
    };
    AFW_HUB.TableUtil.fetch_preset_data(preset, callback);
}
//
// add a row to the column selection table to specify sum or average totals
function add_total_selection_row(table, args) {
    var tr = document.createElement('TR'),
        td = document.createElementWithAttr('TD', {
            style: { textAlign: 'center' }
        }),
        attr = { type: 'radio', style: { display: 'block', margin: 'auto' } },
        input = document.createElementWithAttr('INPUT', attr),
        i;
    //
    // creating selection row
    td = td.cloneNode();
    td.add_children([
        { elm: 'text', textNode: 'Sum' },
        { elm: 'hr' },
        { elm: 'text', textNode: 'Average' }
    ]);
    tr.appendChild(td);
    for (i = 0; i < args.meta_data.length; i++) {
        td = td.cloneNode();
        tr.appendChild(td);
        if (!args.meta_data[i].total_type.match(/avg|sum/i)) {
            continue;
        }
        //
        input = input.cloneNode();
        input.name = args.meta_data[i].db_table_col;
        input.dataset.action = 'total_type';
        input.dataset.column_name = args.meta_data[i].column_name;
        //
        input = input.cloneNode();
        input.type = 'radio';
        input.value = 'sum';
        input.checked = args.meta_data[i].total_type.match(/sum/i);
        args.add_event_handlers(input);
        td.appendChild(input);
        //
        input = input.cloneNode();
        input.value = 'avg';
        input.checked = args.meta_data[i].total_type.match(/avg/i);
        args.add_event_handlers(input);
        td.appendChild(input);
    }
    table.appendChild(tr);
}
//
///////////////////////// Building Production Report //////////////////////////
//
// this function handles creation of the report header for production reports
function make_production_report_header(args) {
    var head = document.createElementWithAttr('DIV', { id: 'report-header' }),
        date_range = '    Date Range: {from_ts} : {to_ts}',
        span = document.createElement('SPAN'),
        br = document.createElement('BR');
    head.style.padding = '5px';
    head.style.borderTop = 'solid 1px rgb(0,0,0)';
    //
    // creating report info head
    span.style.textAlign = 'center';
    span.style.display = 'block';
    span.style.width = '100%';
    if (args.emp_id) {
        span.textContent = 'Report for Employee: ' + args.emp_id;
    } else {
        span.textContent = 'Report for Department: ';
        span.textContent += args.department.replace('_', ' ').toTitleCase();
    }
    //
    head.appendChild(span);
    head.addTextNode(date_range.format(args.ts_obj));
    head.appendChild(br.cloneNode('true'));
    head.appendChild(br.cloneNode('true'));
    //
    document.getElementById(args.table_output_id).safeAppendChild(head);
}
//
// handles construction of the production report
function create_production_report(emp_id, preset_sql_args, response) {
    var department = document.getElementById('department').value,
        time_range_div = document.getElementById('time-range-inputs'),
        update_button = document.getElementById('create-report'),
        structure_fieldset = document.getElementById('structure-parameters'),
        display_table = document.getElementById('report-column-selection'),
        ts_obj = to_and_from_timestamps(time_range_div),
        structure_params = AFW_HUB.FormUtil.get_all_form_values(structure_fieldset),
        display_params = AFW_HUB.TableUtil.process_column_selection_table(
            display_table
        ),
        preset = document.getElementById('preset-report').value || '0',
        pay_period_range = [
            find_pay_period(ts_obj.from_ts)[0],
            find_pay_period(ts_obj.to_ts)[1]
        ],
        section_headers = {
            date: '{date}',
            emp_id: 'Employee {emp_id}: {emp_first_name} {emp_last_name}',
            emp_last_name: 'Employee {emp_id}: {emp_first_name} {emp_last_name}'
        },
        report_args,
        total_types = {},
        col,
        post_data,
        callback;
    //
    // fetching preset data
    if (preset_sql_args === undefined) {
        callback = create_production_report.bind(null, emp_id);
        AFW_HUB.TableUtil.fetch_preset_data(preset, callback);
        return;
    }
    //
    // fetching pay-period data
    if (response === undefined) {
        post_data = {
            data_sql_args: {
                where: [
                    ['date', 'BETWEEN', pay_period_range],
                    ['entry_status', 'LIKE', 'submitted'],
                    ['employee_data.department', 'LIKE', department]
                ],
                order_by: [['date', 'ASC'], ['employee_info.emp_id', 'ASC']]
            }
        };
        //
        callback = create_production_report.bind(null, emp_id, preset_sql_args);
        AFW_HUB.TableUtil.fetch_table_data(
            department + '_report',
            post_data,
            callback
        );
        return;
    }
    //
    // resetting event handler on update button
    update_button.parentNode.safeAppendChild(update_button.cloneNode(true));
    update_button = document.getElementById('create-report');
    update_button.addEventListener(
        'click',
        create_production_report.bind(null, emp_id, undefined, undefined)
    );
    //
    // processing display params to pull out total types
    for (col in display_params.column_data) {
        total_types[col] = display_params.column_data[col].total_type;
    }
    //
    // setting up the report args
    report_args = {
        table_output_id: 'content-div',
        table_name: department + '_report',
        table_attr: {
            id: 'report-table',
            class: 'print-container',
            style: { border: 'solid 1px' }
        },
        department: department,
        pay_period_data: response.table_data,
        ts_obj: ts_obj,
        section_column: structure_params['report-section-column'],
        create_data_rows: !structure_params['report-type-summary'],
        create_section_headers: !structure_params['report-type-no_sect_heads'],
        create_totals_row: !structure_params['report-type-no_totals'],
        display_cols: display_params.display_cols,
        total_types: total_types,
        data_sql_args: Object.merge({ where: [], order_by: [] }, preset_sql_args),
        head_row_args: { sortable: false },
        data_row_attr: {},
        data_cell_attr: {},
        section_row_attr: { class: 'section' },
        section_cell_attr: {
            textContent: section_headers[structure_params['report-section-column']],
            style: { border: 'none' }
        },
        totals_row_attr: {},
        totals_cell_attr: {},
        data_preprocessor: preprocess_report_data.bind(null, department),
        add_callback: postprocess_report_data.bind(null, department)
    };
    report_args.data_sql_args.where.push([
        'employee_data.department',
        'LIKE',
        department
    ]);
    report_args.data_sql_args.where.push([
        'date',
        'BETWEEN',
        [ts_obj.from_ts, ts_obj.to_ts]
    ]);
    report_args.data_sql_args.where.push(['entry_status', 'LIKE', 'submitted']);
    if (emp_id !== null) {
        report_args.data_sql_args.where.push([
            'employee_info.emp_id',
            'LIKE',
            emp_id
        ]);
    }
    report_args.data_sql_args.order_by = [
        [
            structure_params['report-section-column'],
            structure_params['section-sort-dir']
        ],
        [display_params.sort_col[0] || 'emp_id', 'ASC'],
        ['date', 'ASC']
    ];
    //
    // building report
    make_production_report_header(report_args);
    AFW_HUB.TableUtil.create_standard_report(report_args);
    AFW_HUB.Utilities.add_class('hidden-elm', 'create-report');
    AFW_HUB.Utilities.remove_class('hidden-elm', 'print-report');
}
//
///////////////////////// Column Calculation Functions ////////////////////////
//
// clears the extra freight charges and savings from the report
function process_freight_backhaul(args) {
    var i,
        keep = {};
    //
    // setting all but one instance of freight charge and savings for a backhaul to zero
    for (i = 0; i < args.data.length; i++) {
        if (keep[args.data[i].entry_id] === undefined) {
            keep[args.data[i].entry_id] = true;
            continue;
        }
        args.data[i].freight_charge = 0;
        args.data[i].total_savings = 0;
    }
}
//
// this function performs the asynchronous calculation for freight backhaul YTD savings
function calc_freight_backhaul_ytd_savings(args, table, response) {
    var start_date = AFW_HUB.get_constant('FIRST_BUSINESS_DAY').join('-'),
        end_date = args.ts_obj.to_ts.split(' ')[0],
        tr = document.createElementWithAttr('TR', args.totals_row_attr),
        head_td = document.createElementWithAttr('TD', args.totals_cell_attr),
        value_td = document.createElementWithAttr('TD', args.totals_cell_attr),
        disp_args = { add_commas: true, format_str: '$ %value%' },
        sql_args,
        total_type,
        savings,
        col,
        td,
        i,
        callback;
    //
    // fetching data
    if (response === undefined) {
        //
        // setting up SQL args to calculate the YTD total savings
        sql_args = {
            cmd: 'SELECT',
            table: 'employee_data',
            cols: [
                'MAX(employee_data_freight_backhaul.total_savings) total_savings'
            ],
            inner_join: [
                [
                    'employee_data_freight_backhaul',
                    'employee_data.entry_id',
                    'employee_data_freight_backhaul.data_entry_id'
                ]
            ],
            where: [
                ['employee_data.date', 'BETWEEN', [start_date, end_date]],
                ['entry_status', 'LIKE', 'submitted']
            ],
            group_by: 'employee_data_freight_backhaul.data_entry_id'
        };
        sql_args = {
            cmd: 'SELECT',
            cols: ['SUM(total_savings) AS `total_savings`'],
            table: '%total_savings_sub% AS `total_savings`',
            sub_query: { '%total_savings_sub%': sql_args }
        };
        //
        // setting up callback to modify report table
        callback = calc_freight_backhaul_ytd_savings.bind(null, args, table);
        AFW_HUB.Ajax.fetch_db([sql_args], [0], null, callback);
        return;
    }
    //
    // determining colspan for the YTD total
    td = head_td;
    for (i = 1; i < args.meta_data.length; i++) {
        col = args.meta_data[i].column_name;
        total_type = args.total_types[col] || args.meta_data[i].total_type;
        if (total_type.toLowerCase() !== 'none' && td === head_td) {
            td = value_td;
        }
        td.colSpan += 1;
    }
    //
    savings = response[0][0].total_savings;
    table.appendChild(tr);
    tr.style.fontWeight = 'bold';
    tr.appendChild(document.createElement('TD'));
    tr.firstChild.style.border = 'none';
    tr.appendChild(head_td);
    tr.appendChild(value_td);
    head_td.textContent = 'Total Year to Date Savings:';
    AFW_HUB.TableUtil.display_table_data(savings, 'float', value_td, disp_args);
    value_td.style.textAlign = 'center';
}
//
// calculates the amount of overtime a person has
function calc_overtime(args) {
    var pay_data = args.pay_period_data,
        entry_date,
        exit_date = 0,
        wk_hours,
        wk_pay,
        wk_entries, // save an object ref to mutate stuff for receiving
        hours,
        rate,
        daily_ot,
        emp_id,
        i;
    //
    // calculating overtime for each employee
    for (i = 0; i < pay_data.length; i++) {
        //
        // resetting wk hours object if sunday is crossed
        entry_date = new Date(pay_data[i].date + ' 00:00:00');
        if (entry_date > exit_date) {
            if (wk_entries !== undefined && args.department.startsWith('warehouse_')) {
              adjust_receving_overtime_pay(wk_entries, wk_hours, wk_pay);
            }
            wk_entries = {};
            wk_hours = {};
            wk_pay = {};
            exit_date = new Date(entry_date);
            exit_date.setDate(exit_date.getDate() + 6 - exit_date.getDay());
        }
        //
        emp_id = pay_data[i].emp_id;
        hours = Number(pay_data[i].true_hours);
        rate = Number(pay_data[i].hourly_pay_rate);
        daily_ot = 0;
        if (!wk_hours.hasOwnProperty(emp_id)) {
            wk_entries[emp_id] = [];
            wk_hours[emp_id] = 0;
            wk_pay[emp_id] = 0;
        }
        if (wk_hours[emp_id] > 40) {
            daily_ot = hours;
        } else if (wk_hours[emp_id] + hours > 40) {
            daily_ot = wk_hours[emp_id] + hours - 40;
        }
        wk_entries[emp_id].push(pay_data[i]);
        wk_hours[emp_id] += hours;
        wk_pay[emp_id] += hours*rate;
        pay_data[i].daily_ot = daily_ot;
    }
    if (wk_entries !== undefined && args.department.startsWith('warehouse_')) {
      adjust_receving_overtime_pay(wk_entries, wk_hours, wk_pay);
    }
}
//
// this calculates the special incentive for james smith
function calc_shipping_supervisor_incentive(args) {
    var pay_data = args.pay_period_data,
        supervisor_id = AFW_HUB.get_constant('SHIPPING_SUPERVISOR_INCENTIVE').EMP_ID,
        case_bonus = AFW_HUB.get_constant('SHIPPING_SUPERVISOR_INCENTIVE')
            .CASE_BONUS,
        total_cases = 0,
        total_hours = 0,
        total_bonus = 0,
        bonus_per_entry = 0,
        supervisor_entries = [],
        error_dates = [],
        exit_date,
        entry_date,
        i;
    if (pay_data.length == 0) {
      return;
    }
    //
    // stepping over all of the entries to determine if the supervisor
    // gets an incentive for a given week
    exit_date = new Date(pay_data[0].date + ' 00:00:00');
    //
    for (i = 0; i < pay_data.length; i++) {
        entry_date = new Date(pay_data[i].date + ' 00:00:00');
        //
        // outputting incentive if the day changes
        if (entry_date > exit_date) {
            output_incentive();
            //
            // resetting weekly totals
            supervisor_entries = [];
            error_dates = [];
            total_hours = 0;
            total_cases = 0;
            total_bonus = 0;
            bonus_per_entry = 0;
            exit_date = entry_date;
        }
        //
        if (pay_data[i].emp_id + '' === supervisor_id) {
            supervisor_entries.push(pay_data[i]);
            if (pay_data[i].attendance_error !== 'none') {
                error_dates.push(pay_data[i].date);
            }
        }
        total_cases += Number(pay_data[i].num_cases);
        total_hours += Number(pay_data[i].prod_time);
        if (pay_data[i].error_code + '' !== '0') {
            error_dates.push(pay_data[i].date);
        }
    }
    output_incentive();
    //
    // local function to output incentive pay for the supervisor
    function output_incentive() {
        var j, val;
        //
        total_bonus = Math.ceil10(case_bonus * total_cases, 2);
        if (total_cases / total_hours < 100) {
            total_bonus = 0;
        }
        if (!isFinite(total_bonus)) {
            total_bonus = 0;
        }
        //
        // putting smiths bonus in the incentive field
        for (j = 0; j < supervisor_entries.length; j++) {
            bonus_per_entry = total_bonus / supervisor_entries.length;
            if (error_dates.indexOf(supervisor_entries[j].date) > -1) {
                bonus_per_entry = 0;
            }
            supervisor_entries[j].sel_rate = 0;
            supervisor_entries[j].incentive_pay = bonus_per_entry;
            //
            val = Number(supervisor_entries[j].total) + bonus_per_entry;
            supervisor_entries[j].total = val;
        }
    }
}
//
// function to adjust receiving hourly pay using the full week's data
function adjust_receving_overtime_pay(wk_entries, wk_hours, wk_pay) {
  for (var emp_id in wk_hours) {
    if (wk_hours[emp_id] > 40) {
      var ot_rate = 1.5 * (wk_pay[emp_id] / wk_hours[emp_id]);
      for (var i = 0; i < wk_entries[emp_id].length; i++) {
        var entry = wk_entries[emp_id][i];
        entry.hourly_pay = (Number(entry.true_hours) - entry.daily_ot)*Number(entry.hourly_pay_rate) + ot_rate*entry.daily_ot;
        entry.total = entry.hourly_pay + Number(entry.incentive_pay) + Number(entry.additional_pay) - Number(entry.pay_deductions);
      }
    }
  }
}
//
// generic function to recalculate total moves per hour ignoring days
// where they had 0 moves in the given category
function recalculate_total_mph_cols(args) {
    var total_tr,
        tr,
        td,
        total_moves,
        total_prod_time,
        disp_args = { format_str: '%value%', add_commas: true },
        row_data,
        value,
        i,
        col;
    //
    for (i = 0; i < args.totals_rows.length; i++) {
        // sum the moves values in a section
        total_tr = args.totals_rows[i];
        total_moves = {
            receiving_moves: 0,
            total_operations_moves: 0,
            will_call_moves: 0,
            total_moves: 0
        };
        total_prod_time = {
            receiving_moves: 0.0,
            total_operations_moves: 0.0,
            will_call_moves: 0.0,
            total_moves: 0.0
        };
        tr = total_tr.previousSibling;
        while (!tr.classList.contains('section')) {
            for (col in total_moves) {
                if (tr.dataset[col] != '0') {
                    total_moves[col] += Number(tr.dataset[col]);
                    total_prod_time[col] += Number(tr.dataset['prod_time']);
                }
            }
            tr = tr.previousSibling;
        }
        // calculate true move per hour without zero move days
        for (col in total_moves) {
            value = total_moves[col] / total_prod_time[col];
            total_moves[col] = isFinite(value) ? value : 0;
        }
        total_tr.dataset['receiving_moves_per_hr'] = total_moves.receiving_moves;
        td = document.getElementById(total_tr.id + '-' + 'receiving_moves_per_hr');
        td.removeAll();
        AFW_HUB.TableUtil.display_table_data(
            total_moves.receiving_moves,
            'float',
            td,
            disp_args
        );
        total_tr.dataset['operations_moves_per_hr'] =
            total_moves.total_operations_moves;
        td = document.getElementById(total_tr.id + '-' + 'operations_moves_per_hr');
        td.removeAll();
        AFW_HUB.TableUtil.display_table_data(
            total_moves.total_operations_moves,
            'float',
            td,
            disp_args
        );
        total_tr.dataset['will_call_moves_per_hr'] = total_moves.will_call_moves;
        td = document.getElementById(total_tr.id + '-' + 'will_call_moves_per_hr');
        td.removeAll();
        AFW_HUB.TableUtil.display_table_data(
            total_moves.will_call_moves,
            'float',
            td,
            disp_args
        );
        total_tr.dataset['total_moves_per_hour'] = total_moves.total_moves;
        td = document.getElementById(total_tr.id + '-' + 'total_moves_per_hour');
        td.removeAll();
        AFW_HUB.TableUtil.display_table_data(
            total_moves.total_moves,
            'float',
            td,
            disp_args
        );
    }

    // recalculate the total values for the overall totals row
    total_moves = {
        receiving_moves: 0,
        total_operations_moves: 0,
        will_call_moves: 0,
        total_moves: 0
    };
    total_prod_time = {
        receiving_moves: 0.0,
        total_operations_moves: 0.0,
        will_call_moves: 0.0,
        total_moves: 0.0
    };
    for (i = 0; i < args.data.length; i++) {
        row_data = args.data[i];
        for (col in total_moves) {
            if (row_data[col] > 0) {
                total_moves[col] += Number(row_data[col]);
                total_prod_time[col] += Number(row_data['prod_time']);
            }
        }
    }
    // calculate true move per hour without zero move days
    for (col in total_moves) {
        value = total_moves[col] / total_prod_time[col];
        total_moves[col] = isFinite(value) ? value : 0;
    }
    total_tr.dataset['receiving_moves_per_hr'] = total_moves.receiving_moves;
    td = document.getElementById(total_tr.id + '-' + 'receiving_moves_per_hr');
    td.removeAll();
    AFW_HUB.TableUtil.display_table_data(
        total_moves.receiving_moves,
        'float',
        td,
        disp_args
    );
    total_tr.dataset['operations_moves_per_hr'] = total_moves.total_operations_moves;
    td = document.getElementById(total_tr.id + '-' + 'operations_moves_per_hr');
    td.removeAll();
    AFW_HUB.TableUtil.display_table_data(
        total_moves.total_operations_moves,
        'float',
        td,
        disp_args
    );
    total_tr.dataset['will_call_moves_per_hr'] = total_moves.will_call_moves;
    td = document.getElementById(total_tr.id + '-' + 'will_call_moves_per_hr');
    td.removeAll();
    AFW_HUB.TableUtil.display_table_data(
        total_moves.will_call_moves,
        'float',
        td,
        disp_args
    );
    total_tr.dataset['total_moves_per_hour'] = total_moves.total_moves;
    td = document.getElementById(total_tr.id + '-' + 'total_moves_per_hour');
    td.removeAll();
    AFW_HUB.TableUtil.display_table_data(
        total_moves.total_moves,
        'float',
        td,
        disp_args
    );
}
//
// calculates total cost per case
function calc_cost_per_case(args) {
    var data = args.data,
        total,
        num_cases,
        value,
        i;
    //
    for (i = 0; i < data.length; i++) {
        total = Number(args.data[i].total);
        num_cases = Number(args.data[i].num_cases);
        value = isFinite(total / num_cases) ? total / num_cases : 0;
        data[i].cost_per_case = value;
    }
}
//
// calculates total cost per move
function calc_cost_per_move(args) {
    var data = args.data,
        total,
        moves,
        cp,
        i;
    //
    for (i = 0; i < data.length; i++) {
        total = Number(args.data[i].total);
        moves = Number(args.data[i].total_moves);
        cp = total / moves;
        data[i].cost_per_move = isFinite(cp) ? cp : 0;
    }
}
//
// calculates total cost per unit
function calc_cost_per_unit(args) {
    var data = args.data,
        total,
        units,
        cp,
        i;
    //
    for (i = 0; i < data.length; i++) {
        total = Number(args.data[i].total);
        units = Number(args.data[i].total_units);
        cp = total / units;
        data[i].cost_per_unit = isFinite(cp) ? cp : 0;
    }
}
//
// calculates total hourly pay for the employee
function calc_total_hourly_pay(args) {
    var data = args.data,
        i;
    //
    for (i = 0; i < data.length; i++) {
        data[i].hourly_pay = Number(args.data[i].total);
        data[i].hourly_pay -= Number(args.data[i].incentive_pay);
        data[i].hourly_pay -= Number(args.data[i].additional_pay);
        data[i].hourly_pay += Number(args.data[i].pay_deductions);
    }
}
//
// calculates overall average hourly pay rate for employees
function calc_avg_hourly_rate(args) {
    var data = args.data,
        total,
        hours,
        i;
    //
    for (i = 0; i < data.length; i++) {
        total = Number(args.data[i].total);
        hours = Number(args.data[i].hours);
        if (hours === 0) {
            data[i].avg_hourly_rate = 0;
        } else {
            data[i].avg_hourly_rate = total / hours;
        }
    }
}
//
// this adds all of the pay fields except hourly pay into a single value
function calc_amount_to_pay(args) {
    var data = args.data,
        i;
    //
    for (i = 0; i < data.length; i++) {
        data[i].amount_to_pay = 0;
        data[i].amount_to_pay += Number(data[i].additional_pay);
        data[i].amount_to_pay += Number(data[i].incentive_pay);
        data[i].amount_to_pay -= Number(data[i].pay_deductions);
    }
}
//
// generic function to recalculate an A / B column total
function recalculate_total(numerator_col, denominator_col, output_col, args) {
    var tr,
        td,
        disp_args = { format_str: '%value%', add_commas: true },
        meta = args.meta_data_obj[output_col],
        numerator,
        denominator,
        value,
        i;
    if (meta === undefined) {
        return;
    }
    //
    for (i = 0; i < args.totals_rows.length; i++) {
        numerator = Number(args.totals_rows[i].dataset[numerator_col]);
        denominator = Number(args.totals_rows[i].dataset[denominator_col]);
        value = numerator / denominator;
        value = isFinite(value) ? value : 0;
        //
        tr = args.totals_rows[i];
        td = document.getElementById(tr.id + '-' + meta.column_name);
        td.removeAll();
        AFW_HUB.TableUtil.display_table_data(value, meta.data_type, td, disp_args);
    }
}
//
// this calculates the %OT for a report
function calc_percent_ot(args) {
    var tr,
        td,
        i,
        overtime,
        hours,
        perc_ot,
        disp_args = { format_str: 'Percent Overtime: %value%', add_commas: true };
    //
    for (i = 0; i < args.totals_rows.length; i++) {
        hours = Number(args.totals_rows[i].dataset.true_hours);
        overtime = Number(args.totals_rows[i].dataset.daily_ot);
        perc_ot = overtime / hours;
        perc_ot = isFinite(perc_ot) ? perc_ot : 0;
        //
        // creating special totals row from existing totals row
        tr = args.totals_rows[i].cloneNode();
        tr.id = Math.floor(Math.random() * 1000000000);
        args.totals_rows[i].parentNode.insertBefore(
            tr,
            args.totals_rows[i].nextSibling
        );
        //
        // adding label cell and/or spacer cell if using section headers
        if (args.create_section_headers) {
            tr.appendChild(args.totals_rows[i].firstChild.cloneNode());
            td = args.totals_rows[i].firstChild.nextSibling.cloneNode();
            td.textContent = args.totals_rows[i].firstChild.nextSibling.textContent;
            tr.appendChild(td);
        } else {
            td = args.totals_rows[i].firstChild.cloneNode(true);
            tr.appendChild(td);
        }
        //
        // adding cell that spans remainder of report
        td = td.cloneNode();
        td.colSpan = args.meta_data.length - tr.firstChild.colSpan;
        tr.appendChild(td);
        AFW_HUB.TableUtil.display_table_data(perc_ot, 'percent', td, disp_args);
        td.style.textAlign = 'center';
    }
}
//
// driver function to pre-proess report data
function preprocess_report_data(department, report_args) {
    var data = report_args.data,
        pay_data = report_args.pay_period_data,
        meta_data = report_args.meta_data,
        mapper = {},
        i;
    //
    // creating a mapping object to pass pay-period data to table data
    for (i = 0; i < pay_data.length; i++) {
        mapper[pay_data[i].entry_id] = pay_data[i];
    }
    // resetting mapping reference to table data where possible
    for (i = 0; i < data.length; i++) {
        mapper[data[i].entry_id] = data[i];
    }
    // recreating pay_period_data array using mapper
    // now objects are shared between data and pay_period_data arrays
    for (i = 0; i < pay_data.length; i++) {
        pay_data[i] = mapper[pay_data[i].entry_id];
    }
    //
    // creating a meta data object indexed by column name
    report_args.meta_data_obj = {};
    for (i = 0; i < meta_data.length; i++) {
        report_args.meta_data_obj[meta_data[i].column_name] = meta_data[i];
    }
    //
    // performing frieght backhaul specific calcualtions
    if (department === 'freight_backhaul') {
        process_freight_backhaul(report_args);
        return;
    }
    calc_overtime(report_args);
    //
    // preforming additional calculations for departments as needed
    if (department === 'transportation') {
        for (i = 0; i < data.length; i++) {
            data[i].incentive_pay = data[i].driver_incentive_pay;
        }
    }
    if (department === 'warehouse_receiving') {
        calc_cost_per_move(report_args);
        calc_cost_per_unit(report_args);
    }
    if (department === 'warehouse_shipping') {
        calc_shipping_supervisor_incentive(report_args);
        calc_cost_per_case(report_args);
    }
    //
    // post calculations
    calc_total_hourly_pay(report_args);
    calc_avg_hourly_rate(report_args);
    calc_amount_to_pay(report_args);
}
//
// driver function to post-process report data
function postprocess_report_data(department, report_args, table) {
    //
    if (department === 'freight_backhaul') {
        calc_freight_backhaul_ytd_savings(report_args, table);
        return;
    }
    //
    recalculate_total('total', 'hours', 'avg_hourly_rate', report_args);
    if (department === 'transportation') {
        recalculate_total('total', 'miles', 'cost_per_mile', report_args);
        recalculate_total('total', 'num_routes', 'cost_per_route', report_args);
        recalculate_total('total', 'num_stops', 'cost_per_stop', report_args);
        recalculate_total('total', 'num_cases', 'cost_per_case', report_args);
        recalculate_total('miles', 'truck_fuel', 'miles_per_gallon', report_args);
        return;
    }
    //
    calc_percent_ot(report_args);
    if (department === 'warehouse_receiving') {
        recalculate_total_mph_cols(report_args);
        recalculate_total('total_moves', 'prod_time', 'moves_hour', report_args);
        recalculate_total('total_units', 'prod_time', 'units_hour', report_args);
        recalculate_total('total', 'total_moves', 'cost_per_move', report_args);
        recalculate_total('total', 'total_units', 'cost_per_unit', report_args);
    }
    if (department === 'warehouse_shipping') {
        recalculate_total('num_cases', 'prod_time', 'cases_hr', report_args);
        recalculate_total('total', 'num_cases', 'cost_per_case', report_args);
    }
}
