/*global AFW_HUB*/
'use strict';
//
//
var returns_form_funcs = function() {
    //
    // sets up the aux div
    function setup_aux_div() {
        var aux_div, style, aux_container, divs, button;
        style = {
            clear: 'none',
            position: 'relative',
            float: 'right',
            top: '1rem',
            right: '0rem',
            width: '50%',
            overflow: 'scroll',
            padding: '2px',
            maxWidth: '50rem',
            backgroundColor: 'rgb(255,255,255)'
        };
        aux_div = document.createElementWithAttr('DIV', {
            id: 'auxillary-div',
            style: style
        });
        aux_container = document.createElementWithAttr('DIV', {
            id: 'aux-container'
        });
        //
        divs = [
            document.createElementWithAttr('H3', { id: 'auxillary-div-header' }),
            document.createElementWithAttr('DIV', { id: 'refine-div' }),
            document.createElement('BR'),
            document.createElementWithAttr('DIV', { id: 'table-div' }),
            document.createElementWithAttr('H3', { id: 'content-header' }),
            document.createElementWithAttr('DIV', { id: 'content-div' })
        ];
        aux_container.addNodes(divs);
        //
        button = document.createElementWithAttr('BUTTON', {
            id: 'hide-auxillary-div'
        });
        button.textContent = 'Show Selection Tables';
        button.addEventListener(
            'click',
            toggle_view_element_button.bind(
                null,
                button,
                aux_container,
                'Hide Selection Table',
                'Show Selection Table'
            )
        );
        //
        aux_div.addNodes([ button, aux_container ]);
        //
        AFW_HUB.Utilities.add_class('hidden-elm', aux_div);
        AFW_HUB.Utilities.add_class('hidden-elm', aux_container);
        //
        return aux_div;
    }
    //
    // clears all children from the auxiullary div
    function clear_aux_div() {
        //
        var container = document.getElementById('aux-container');
        var ids = [ 'refine-div', 'table-div', 'content-div' ];
        for (var i = 0; i < ids.length; i++) {
            var div = document.getElementById(ids[i]);
            container.replaceChild(div.cloneNode(), div);
        }
        AFW_HUB.Utilities.add_class('hidden-elm', container);
        document.getElementById('hide-auxillary-div').value = 'update-button';
        document.getElementById('hide-auxillary-div').dispatchPrimaryEvent();
    }
    //
    // hides the aux div after clicking on a table row
    function hide_after_row_click() {
        //
        AFW_HUB.Utilities.add_class('hidden-elm', 'auxillary-div');
        AFW_HUB.Utilities.add_class('hidden-elm', 'aux-container');
        document.getElementById('hide-auxillary-div').value = 'update-button';
        document.getElementById('hide-auxillary-div').dispatchPrimaryEvent();
    }
    //
    function check_cust_id(data) {
        if (data) {
            if (data['data'] && data['data'].length) {
                data = data['data'][0];
                AFW_HUB.Utilities.remove_class('boxshadow-red', 'customer-id');
                data['customer_id'] = data['customer_id'].toUpperCase().trim();
                document.getElementById('customer-id').value = data['customer_id'];
                document.getElementById(
                    'customer-name'
                ).value = data['customer_name'];
                document.getElementById('rep-id').value = data['rep_id'];
                document.getElementById('rep-name').value = data['rep_first_name'];
            } else {
                AFW_HUB.Utilities.add_class('boxshadow-red', 'customer-id');
            }
            return;
        }
        var cust_id = document.getElementById('customer-id').value;
        var sql_args = {
            table: 'sales_customer_table',
            inner_join: [
                [
                    'sales_rep_table',
                    'sales_customer_table.rep_id',
                    'sales_rep_table.rep_id'
                ]
            ],
            where: [ [ 'customer_id', 'REGEXP', '^ *{} *$'.format(cust_id) ] ]
        };
        AFW_HUB.Ajax.fetch_db([ sql_args ], [ 'data' ], null, check_cust_id);
    }
    //
    function show_customer_table() {
        //
        AFW_HUB.Utilities.add_class('hidden-elm', 'main-table-div');
        AFW_HUB.Utilities.remove_class('hidden-elm', 'auxillary-div');
        if (document.getElementById('sales_customer_table')) {
            return;
        }
        clear_aux_div();
        // setting up a new row_onclick for the customer table
        var row_onclick = function(row_id) {
            var data = document.getElementById(row_id).dataset;
            AFW_HUB.Utilities.remove_class('boxshadow-red', 'customer-id');
            AFW_HUB.Utilities.remove_class('boxshadow-red', 'rep-id');
            AFW_HUB.Utilities.remove_class('boxshadow-red', 'dsr-route-number');
            document.getElementById('customer-id').value = String.trim(
                data['customer_id']
            );
            document.getElementById('customer-name').value = String.trim(
                data['customer_name']
            );
            document.getElementById('rep-id').value = String.trim(data['rep_id']);
            document.getElementById('rep-name').value = String.trim(
                data['sales_rep_name']
            );
        };
        var tbl_args = {
            row_onclick: [
                { func: row_onclick, args: [ '%row_id%' ] },
                { func: hide_after_row_click, args: [] }
            ]
        };
        //
        // creating refinement fieldset with different customer table func
        var table_fun = create_customer_table.bind(
            null,
            1,
            'customer_id',
            'ASC',
            tbl_args
        );
        var fieldset = create_customer_table_refinement(table_fun);
        document.getElementById('refine-div').safeAppendChild(fieldset);
        var button = document.getElementById('new-customer');
        var hide_table = function() {
            var event = document.createEvent('HTMLEvents');
            event.initEvent('click', true, false);
            document.getElementById('show-customer-table').dispatchEvent(event);
        };
        button.addEventListener('click', hide_table);
        //
        // setting up a new reset function for the customer form
        window.reset_customer_form = function() {
            //
            alert(this.success_message);
            var form = document.getElementById('sales-customer-form');
            var form_vals = AFW_HUB.FormUtil.get_all_form_values(form);
            clear_aux_div();
            AFW_HUB.Utilities.add_class('hidden-elm', 'auxillary-div');
            document.getElementById('customer-id').value = form_vals['customer_id'];
            document.getElementById(
                'customer-name'
            ).value = form_vals['customer_name'];
            document.getElementById('rep-id').value = form_vals['rep_id'];
            document.getElementById('rep-name').value = '';
        };
        //
        table_fun();
    }
    //
    function check_emp_id(prefix, data) {
        if (data) {
            if (data['data'] && data['data'].length) {
                data = data['data'][0];
                AFW_HUB.Utilities.remove_class('boxshadow-red', prefix + '-emp-id');
                var name = '{emp_first_name} {emp_last_name}'.format(data);
                document.getElementById(prefix + '-emp-id').value = data['emp_id'];
                document.getElementById(prefix + '-name').value = name;
            } else {
                AFW_HUB.Utilities.add_class('boxshadow-red', prefix + '-emp-id');
            }
            return;
        }
        var emp_id = document.getElementById(prefix + '-emp-id').value;
        var sql_args = {
            table: 'employee_info',
            where: [ [ 'emp_id', 'LIKE', emp_id ] ]
        };
        AFW_HUB.Ajax.fetch_db(
            [ sql_args ],
            [ 'data' ],
            null,
            check_emp_id.bind(null, prefix)
        );
    }
    //
    function show_employee_table(department, prefix) {
        //
        function sales_emp_table(page, sort_col, sort_dir) {
            var data_sql_args = {},
                args = {},
                row_onclick = function(row_id) {
                    var data = document.getElementById(row_id).dataset;
                    var name = '{emp_first_name} {emp_last_name}'.format(data);
                    AFW_HUB.Utilities.remove_class(
                        'boxshadow-red',
                        prefix + '-emp-id'
                    );
                    document.getElementById(prefix + '-emp-id').value = String.trim(
                        data['emp_id']
                    );
                    document.getElementById(prefix + '-name').value = name;
                };
            //
            data_sql_args.where = [
                [ 'department', 'LIKE', department ],
                [ 'emp_status', 'LIKE', 'active' ]
            ];
            data_sql_args.order_by = [ [ sort_col, sort_dir ] ];
            //
            args = {
                table_name: 'employee_table',
                table_output_id: 'table-div',
                table_attr: { id: 'employee-table' },
                row_id_prefix: 'emp-row-',
                data_sql_args: data_sql_args,
                curr_page: page,
                row_onclick: [
                    { func: row_onclick, args: [ '%row_id%' ] },
                    { func: hide_after_row_click, args: [] }
                ],
                head_row_args: {
                    sort_col: sort_col,
                    sort_dir: sort_dir,
                    sort_onclick: [
                        {
                            func: sales_emp_table,
                            args: [ 1, '%column_name%', '%sort_dir%' ]
                        }
                    ]
                },
                page_nav_args: {
                    curr_page: page,
                    sort_col: sort_col,
                    sort_dir: sort_dir,
                    page_nav_div_attr: { id: 'emp-table-page-nav' },
                    id_prefix: 'emp',
                    link_onclick: [
                        {
                            func: sales_emp_table,
                            args: [ '%page%', sort_col, sort_dir ]
                        }
                    ]
                }
            };
            AFW_HUB.TableUtil.create_standard_table(args);
        }
        //
        AFW_HUB.Utilities.add_class('hidden-elm', 'main-table-div');
        AFW_HUB.Utilities.remove_class('hidden-elm', 'auxillary-div');
        AFW_HUB.Utilities.remove_class('hidden-elm', 'aux-container');
        clear_aux_div();
        sales_emp_table(1, 'emp_id', 'ASC');
    }
    //
    function check_item_num(data) {
        var item_num = document.getElementById('item-number').value;
        if (data) {
            if (data['data'] && data['data'].length) {
                data = data['data'][0];
                AFW_HUB.Utilities.remove_class('boxshadow-red', 'item-number');
                item_num = String.trim(data['item_number']);
                var desc = String.trim(data['descript']);
                AFW_HUB.Utilities.remove_class('boxshadow-red', 'item-number');
                document.getElementById('item-number').value = item_num;
                document.getElementById('item-desc').value = desc;
            } else {
                document.getElementById('item-desc').value = '';
                AFW_HUB.Utilities.add_class('boxshadow-red', 'item-number');
            }
            return;
        }
        var sql_args = {
            cmd: 'SELECT',
            table: 'afwg_prod_data.products',
            cols: [ '(`item number`) AS item_number', 'descript' ],
            where: [ [ '`item number`', 'LIKE', item_num ] ]
        };
        AFW_HUB.Ajax.fetch_db(
            [ sql_args ],
            [ 'data' ],
            null,
            check_item_num.bind(null)
        );
    }
    //
    function show_products_table() {
        //
        function sales_products_table(page, sort_col, sort_dir) {
            //
            // setting up row onclick to populate form fields
            var container = document.getElementById('product-table-refinement'),
                row_onclick = function(row_id) {
                    var data = document.getElementById(row_id).dataset;
                    var item_num = String.trim(data['item_number']);
                    var desc = String.trim(data['descript']);
                    AFW_HUB.Utilities.remove_class('boxshadow-red', 'item-number');
                    document.getElementById('item-number').value = item_num;
                    document.getElementById('item-desc').value = desc;
                },
                table_args = {
                    table_name: 'product_data',
                    table_output_id: 'table-div',
                    table_attr: { id: 'sales-product-table' },
                    row_id_prefix: 'item-row-',
                    row_onclick: [
                        { func: row_onclick, args: [ '%row_id%' ] },
                        { func: hide_after_row_click, args: [] }
                    ],
                    data_sql_args: {
                        sub_query: {
                            '%item_data%': {
                                cmd: 'SELECT',
                                cols: [
                                    '`item number` AS `item_number`',
                                    '`stock status` AS `stock_status`',
                                    'unique_index'
                                ],
                                table: 'afwg_prod_data.products'
                            }
                        },
                        where: [],
                        order_by: [ [ sort_col, sort_dir ] ]
                    },
                    head_row_args: {
                        sort_col: sort_col,
                        sort_dir: sort_dir,
                        sort_onclick: [
                            {
                                func: sales_products_table,
                                args: [ 1, '%column_name%', '%sort_dir%' ]
                            }
                        ]
                    },
                    page_nav_args: {
                        curr_page: page,
                        sort_col: sort_col,
                        sort_dir: sort_dir,
                        tot_pages_shown: 9,
                        num_per_page: 20,
                        page_nav_div_attr: { id: 'product-table-page-nav' },
                        id_prefix: 'item',
                        link_onclick: [
                            {
                                func: sales_products_table,
                                args: [ '%page%', sort_col, sort_dir ]
                            }
                        ]
                    },
                    regen_function: sales_products_table.bind(
                        null,
                        1,
                        sort_col,
                        sort_dir
                    )
                };
            //
            AFW_HUB.TableUtil.get_table_inputs(table_args.data_sql_args, container);
            AFW_HUB.TableUtil.create_standard_table(table_args);
        }
        //
        // unhiding aux div and clearing any leftover content if the table doesn't exist
        AFW_HUB.Utilities.add_class('hidden-elm', 'main-table-div');
        AFW_HUB.Utilities.remove_class('hidden-elm', 'auxillary-div');
        if (document.getElementById('sales-product-table')) {
            return;
        }
        clear_aux_div();
        //
        // creating some refinement fields
        var tbl_func = function() {
            document.getElementById('sales-product-table').dispatchPrimaryEvent();
        };
        tbl_func = tbl_func.bind(null, sales_products_table);
        var fieldset = document.createElementWithAttr('FIELDSET', {
            id: 'product-table-refinement'
        });
        document.getElementById('refine-div').safeAppendChild(fieldset);
        var refine_elms = [
            { elm: 'legend', textNode: 'Refine Item Table By:' },
            { elm: 'label', textNode: 'Item Number:' },
            {
                elm: 'input',
                type: 'text',
                id: 'ref-item-number',
                name: 'item_number',
                events: [ { event: 'keyup', function: tbl_func } ]
            },
            { elm: 'br' },
            { elm: 'label', textNode: 'Item Description:' },
            {
                elm: 'input',
                type: 'text',
                id: 'ref-item-desc',
                name: 'descript',
                events: [ { event: 'keyup', function: tbl_func } ]
            },
            { elm: 'br' },
            { elm: 'label', textNode: 'Unit:' },
            {
                elm: 'select',
                type: 'text',
                id: 'ref-unit',
                name: 'unit',
                events: [ { event: 'change', function: tbl_func } ]
            },
            { elm: 'br' },
            { elm: 'label', textNode: 'Stock Status:' },
            {
                elm: 'select',
                type: 'text',
                id: 'ref-stock-status',
                name: 'stock_status',
                events: [ { event: 'change', function: tbl_func } ]
            }
        ];
        fieldset.add_children(refine_elms);
        //
        // populating the two dropboxes
        var dropbox_args = {
            dropbox_id: 'ref-unit',
            text_format: '%unit%',
            value_format: '^%unit%$',
            placeholder: 'ALL',
            placeholder_value: '.',
            placeholder_disabled: false,
            placeholder_selected: true,
            sql_args: {
                cmd: 'SELECT',
                table: 'afwg_prod_data.products',
                cols: [ 'DISTINCT(`unit`)`unit`' ]
            }
        };
        AFW_HUB.FormUtil.populate_dropbox_options(dropbox_args);
        dropbox_args = {
            dropbox_id: 'ref-stock-status',
            text_format: '%stock_status%',
            value_format: '^%stock_status%$',
            placeholder: 'ALL',
            placeholder_value: '.',
            placeholder_disabled: false,
            placeholder_selected: true,
            sql_args: {
                cmd: 'SELECT',
                table: 'afwg_prod_data.products',
                cols: [ 'DISTINCT(`stock status`)`stock_status`' ]
            }
        };
        AFW_HUB.FormUtil.populate_dropbox_options(dropbox_args);
        //
        sales_products_table(1, 'descript', 'ASC');
    }
    //
    return {
        setup_aux_div: setup_aux_div,
        clear_aux_div: clear_aux_div,
        check_cust_id: check_cust_id.bind(null, null),
        show_customer_table: show_customer_table,
        check_emp_id: check_emp_id,
        show_employee_table: show_employee_table,
        check_item_num: check_item_num,
        show_products_table: show_products_table
    };
};
///////////////////////////////////////////////////////////////////////////////
//
// validating the sales rep form
function rep_form_validation(form, act, response) {
    var form_values = AFW_HUB.FormUtil.get_all_form_values(form),
        error = false,
        sql_arr, callback, args;
    //
    // fetching data for unique checks
    if (response === undefined) {
        sql_arr = [
            {
                cmd: 'SELECT',
                table: 'sales_rep_table',
                where: [
                    ['rep_id', 'LIKE', form_values.rep_id]
                ]
            },
            {
                cmd: 'SELECT',
                table: 'sales_rep_table',
                where: [
                    ['dbuser_internal_id', 'LIKE', form_values.dbuser_internal_id]
                ]
            }
        ];
        callback = rep_form_validation.bind(null, form, act);
        AFW_HUB.Ajax.fetch_db(sql_arr, ['rep_id_check', 'login_check'], null, callback);
        return;
    }
    //
    // checking uniqueness of values and for general form errors
    args = [
        document.getElementById('rep-id'),
        document.getElementById('internal-id'),
        null,
        null,
        null,
        [response.rep_id_check]
    ];
    AFW_HUB.FormUtil.check_unique.apply(null, args);
    //
    args = [
        document.getElementById('dbuser-internal-id'),
        document.getElementById('internal-id'),
        null,
        null,
        null,
        [response.login_check]
    ];
    AFW_HUB.FormUtil.check_unique.apply(null, args);
    //
    error = AFW_HUB.FormUtil.auto_validate(form);
    if (error) { return;}
    submit_sales_rep_form(form, act);
}
//
// submits sales rep form to database
function submit_sales_rep_form(form, act) {
    var form_values = AFW_HUB.FormUtil.get_all_form_values(form),
        msg = 'Confirm ' + act + ' of Sales Rep: {rep_first_name} {rep_last_name}',
        callback = reset_sales_rep_form.bind(null, act);
    //
    if (!confirm(msg.format(form_values))) {
        return;
    }
    //
    if (act === 'creation') {
        delete form_values.internal_id;
        form_values.rep_status = 'active';
    } else if (act == 'deletion') {
        form_values.rep_status = 'inactive';
    } else if (act == 'restoration') {
        form_values.rep_status = 'active';
    }
    //
    AFW_HUB.Ajax.submit_form_values(form.name, form_values, callback);
}
//
// resets the page after sucessful form submission
function reset_sales_rep_form(act) {
    alert('Sucessful ' + act + ' of Sales Rep');
    //
    document.getElementById('sales_rep_table').dispatchPrimaryEvent();
    document.getElementById('content-header').removeAll();
    document.getElementById('content-div').removeAll();
}
///////////////////////////////////////////////////////////////////////////////
//
// validates the customer form
function customer_form_validation(form, act, unique_err) {
    var error = false, args;
    //
    // checking customer id
    if (unique_err === undefined) {
        args = [
            document.getElementById('customer-id'),
            document.getElementById('customer-internal-id'),
            'sales_customer_table',
            null,
            customer_form_validation.bind(null, form, act)
        ];
        AFW_HUB.FormUtil.check_unique.apply(null, args);
        return;
    }
    error = AFW_HUB.FormUtil.auto_validate(form);
    if (error) {
        return;
    }
    //
    submit_customer_form(form, act);
}
//
// submits the customer form to the database
function submit_customer_form(form, act) {
    var msg = 'Confirm ' + act +' of Customer: {customer_id} {customer_name}',
        form_values = AFW_HUB.FormUtil.get_all_form_values(form),
        callback = reset_customer_form.bind(null, act);
    //
    // defining action based values
    if (act === 'creation') {
        delete form_values.customer_internal_id;
        form_values.customer_status = 'active';
    } else if (act == 'deletion') {
        form_values.customer_status = 'inactive';
    } else if (act == 'reinstatement') {
        form_values.customer_status = 'active';
    }
    //
    if (!confirm(msg.format(form_values))) {
        return;
    }
    AFW_HUB.Ajax.submit_form_values(form.name, form_values, callback);
}
//
// resets the page after sucessful form submission
function reset_customer_form(act) {
    alert('Sucessful ' + act + ' of Customer');
    //
    document.getElementById('sales_customer_table').dispatchPrimaryEvent();
    document.getElementById('content-header').removeAll();
    document.getElementById('content-div').removeAll();
}
///////////////////////////////////////////////////////////////////////////////
//
// validating the returns form
function returns_form_validation(form, act) {
    var buyer_resp_req = document.getElementById('edit-buyer-response').checked,
        rep_resp_req = document.getElementById('edit-rep-response').checked,
        form_values = AFW_HUB.FormUtil.get_all_form_values(form),
        errors = AFW_HUB.FormUtil.auto_validate(form);
    //
    if (errors) {
        return;
    }
    //
    // handling required responses
    form_values.entry_status = '';
    if (buyer_resp_req && form_values.buyer_response === '') {
        form_values.entry_status += 'buyer_response_req%';
    }
    if (rep_resp_req && form_values.rep_response === '') {
        form_values.entry_status += 'rep_response_req%';
    }
    if (form_values.entry_status === '') {
        form_values.entry_status = 'completed';
    }
    //
    submit_returns_form(form, act, form_values);
}
//
// handles submission of returns form
function submit_returns_form(form, act, form_values) {
    var msg = 'Confirm ' + act + ' of return entry for Item: {item_number}',
        callback = reset_returns_form.bind(null, act, form_values);
    //
    if (!confirm(msg.format(form_values))) {
        return;
    }
    //
    // defining action based form values
    if (act === 'creation') {
        delete form_values.entry_id;
        form_values.entering_user = window.sessionStorage.username;
    }
    else {
        form_values.return_last_modified = Date.current_ts();
        form_values.return_last_modified_by = window.sessionStorage.username;
    }
    if (act === 'deletion') {
        form_values.entry_status = 'deleted';
    }
    //
    // building main form submission sql
    AFW_HUB.Ajax.submit_form_values(form.name, form_values, callback);
}
//
// resets the page after sucessful submission of returns form
function reset_returns_form(act, form_values) {
    var msg = 'Sucessful ' + act + ' of return entry for Item: {item_number}';
    //
    // regenerating table
    if (document.getElementById('sales_items_returns_table')) {
        document.getElementById('sales_items_returns_table').dispatchPrimaryEvent();
    }
    //
    // clearing page elements
    AFW_HUB.Utilities.add_class('hidden-elm', 'auxillary-div');
    document.getElementById('main-form-header').removeAll();
    document.getElementById('main-form-div').removeAll();
    alert(msg.format(form_values));
}
