/*global AFW_HUB*/
/*eslint-disable camelcase */
/*eslint-disable no-alert */
/*eslint-disable no-use-before-define */
/*eslint-disable global-strict */
////////////////////////////////////////////////////////////////////////////////
//////////  This file holds functions associated with employee       ///////////
//////////  setup                                                   ///////////
////////////////////////////////////////////////////////////////////////////////
'use strict';
//
/////////////////////////// Page Setup functions ///////////////////////////////
//
// sets the page for employee creation or modifcation
function setup_employee_page() {
    //
    // creating/getting elements
    var table_fieldset = document.getElementById('table-fieldset');
    var br = document.createElement('BR');
    var label = document.createElement('LABEL');
    label.textContent = 'Show Inactive Employees:  ';
    var checkbox = document.createElementWithAttr('INPUT', {
        id: 'show-inactive',
        type: 'checkbox',
        value: '^active$'
    });
    checkbox.addEventListener(
        'click',
        AFW_HUB.FormUtil.toggle_checkbox_value.bind(null, checkbox, '.', '^active$')
    );
    checkbox.addEventListener(
        'click',
        mod_emp_table.bind(null, 1, 'emp_last_name', 'ASC')
    );
    var button = document.createElementWithAttr('BUTTON', {
        id: 'create-new-employee'
    });
    button.textContent = 'Create New Employee';
    button.addEventListener('click', mod_employee_info.bind(null, null, null, null));
    //
    // setting up page
    document.getElementById('page-header').textContent = 'Employee Setup';
    document.getElementById('table-legend').textContent = 'Select Employee';
    table_fieldset.addNodes([ br, label, checkbox ]);
    table_fieldset.parentNode.insertBefore(button, table_fieldset.nextSibling);
    table_fieldset.parentNode.insertBefore(
        br.cloneNode(),
        table_fieldset.nextSibling
    );
    //
    mod_emp_table(1, 'emp_last_name', 'ASC');
}
//
////////////////////////////////////////////////////////////////////////////////
/////////////////////// Table Generation functions /////////////////////////////
//
// generic function to create an employee table
function mod_emp_table(page, sort_col, sort_dir) {
    var show_inactive = document.getElementById('show-inactive').value, table_args;
    //
    table_args = {
        table_name: 'employee_table',
        data_sql_args: {
            where: [ [ 'emp_status', 'REGEXP', show_inactive ] ],
            order_by: [ [ sort_col, sort_dir ] ]
        },
        table_output_id: 'table-fieldset',
        table_attr: { id: 'employee-table' },
        row_id_prefix: 'emp-row-',
        row_onclick: [
            {
                func: mod_employee_info,
                args: [ '%emp_internal_id%', '%row_id%', null ]
            }
        ],
        head_row_args: {
            sort_col: sort_col,
            sort_dir: sort_dir,
            sort_onclick: [
                { func: mod_emp_table, args: [ 1, '%column_name%', '%sort_dir%' ] }
            ]
        },
        page_nav_args: {
            curr_page: page,
            sort_col: sort_col,
            sort_dir: sort_dir,
            tot_pages_shown: 9,
            num_per_page: 10,
            page_nav_div_attr: { id: 'emp-table-page-nav' },
            id_prefix: 'emp',
            link_onclick: [
                { func: mod_emp_table, args: [ '%page%', sort_col, sort_dir ] }
            ]
        }
    };
    //
    AFW_HUB.TableUtil.create_standard_table(table_args);
}
////////////////////////////////////////////////////////////////////////////
/////////////////////// Form initialization ////////////////////////////////
//
// sets up the form for editing employee information
//
function add_employee_form_listeners(form, meta_array) {
    var meta_data = meta_array.to_object('column_name'),
        event_args = {
            meta_data: meta_data,
            add_default_events: function(elm) {
                var event = elm.primaryEventString();
                if (elm.nodeName.toLowerCase() === 'button') {
                    return;
                }
                if (!event) {
                    return;
                }
                if (elm.type === 'hidden') {
                    return;
                }
                //
                elm.addEventListener(
                    event,
                    AFW_HUB.Utilities.remove_class.bind(null, 'boxshadow-red', elm)
                );
            }
        },
        get_option_text = function(select_id, out_id) {
            var i = document.getElementById(select_id).selectedIndex,
                opt = document.getElementById(select_id).options,
                str = opt[i].text;
            document.getElementById(out_id).value = str;
        },
        sel, chk_box;
    delete meta_data.emp_comments;
    AFW_HUB.FormUtil.add_standard_event_listeners(form, event_args);
    //
    // creating a function to get option text from a select box
    sel = document.getElementById('base-rate');
    sel.addEventListener(
        'change',
        get_option_text.bind(null, 'base-rate', 'base-rate-level')
    );
    sel = document.getElementById('case-rate');
    sel.addEventListener(
        'change',
        get_option_text.bind(null, 'case-rate', 'case-rate-level')
    );
    sel = document.getElementById('stop-rate');
    sel.addEventListener(
        'change',
        get_option_text.bind(null, 'stop-rate', 'stop-rate-level')
    );
    //
    chk_box = document.getElementById('lead-receiver');
    chk_box.addEventListener(
        'click',
        function () {
            AFW_HUB.FormUtil.toggle_checkbox_value(document.getElementById('lead-receiver'), 1, 0);
        }
    );
    chk_box = document.getElementById('lead-picker');
    chk_box.addEventListener(
        'click',
        function () {
            AFW_HUB.FormUtil.toggle_checkbox_value(document.getElementById('lead-picker'), 1, 0);
        }
    );
    //
    // adding the validation function to the button
    document
        .getElementById('submit-employee-form')
        .addEventListener(
            'click',
            validate_employee_form.bind(null, form, 'creation')
        );
}
//
function mod_employee_info(emp_internal_id, row_id, form) {
    var form_div = document.getElementById('form-div'),
        args,
        form_args,
        callback,
        row_data,
        msg,
        mod_button,
        del_button,
        res_button;
    //
    // loading form
    if (!form) {
        callback = mod_employee_info.bind(null, emp_internal_id, row_id);
        AFW_HUB.FormUtil.load_html_form('employee_form', form_div, callback);
        return;
    }
    //
    // setting up the multiple container args
    args = {
        methods: [
            {
                function: AFW_HUB.FormUtil.populate_dropbox_options,
                output_key: 'department_dropbox_data',
                args: {
                    dropbox_id: 'department',
                    text_format: '%department_name%',
                    value_format: '%department%',
                    placeholder: 'Select Department',
                    add_opts_val: [ 'other' ],
                    add_opts_text: [ 'Other' ],
                    database: 'misc_database',
                    sql_args: {
                        cmd: 'SELECT',
                        table: 'departments',
                        cols: [ 'department', 'department_name' ],
                        where: [
                            [ 'department_type', 'REGEXP', '(^|%)employees(%|$)' ]
                        ]
                    }
                }
            },
            {
                function: AFW_HUB.FormUtil.populate_dropbox_options,
                output_key: 'base_rate_dropbox_data',
                args: {
                    dropbox_id: 'base-rate',
                    text_format: '%level%',
                    value_format: '%value%',
                    placeholder: 'Select Level',
                    placeholder_value: '0',
                    add_opts_val: [ '0', '0' ],
                    add_opts_text: [ 'Other', 'N/A' ],
                    database: 'misc_database',
                    sql_args: {
                        cmd: 'SELECT',
                        table: 'driver_levels',
                        cols: [ 'value', 'level' ],
                        where: [ [ 'level_name', 'LIKE', 'base_rate_level' ] ]
                    }
                }
            },
            {
                function: AFW_HUB.FormUtil.populate_dropbox_options,
                output_key: 'case_rate_dropbox_data',
                args: {
                    dropbox_id: 'case-rate',
                    text_format: '%level%',
                    value_format: '%value%',
                    placeholder: 'Select Level',
                    placeholder_value: '0',
                    add_opts_val: [ '0', '0' ],
                    add_opts_text: [ 'Other', 'N/A' ],
                    database: 'misc_database',
                    sql_args: {
                        cmd: 'SELECT',
                        table: 'driver_levels',
                        cols: [ 'value', 'level' ],
                        where: [ [ 'level_name', 'LIKE', 'case_rate_level' ] ]
                    }
                }
            },
            {
                function: AFW_HUB.FormUtil.populate_dropbox_options,
                output_key: 'stop_rate_dropbox_data',
                args: {
                    dropbox_id: 'stop-rate',
                    text_format: '%level%',
                    value_format: '%value%',
                    placeholder: 'Select Level',
                    placeholder_value: '0',
                    add_opts_val: [ '0', '0' ],
                    add_opts_text: [ 'Other', 'N/A' ],
                    database: 'misc_database',
                    sql_args: {
                        cmd: 'SELECT',
                        table: 'driver_levels',
                        cols: [ 'value', 'level' ],
                        where: [ [ 'level_name', 'LIKE', 'stop_rate_level' ] ]
                    }
                }
            }
        ]
    };
    form_args = {
        function: AFW_HUB.FormUtil.populate_form,
        output_key: 'form_data',
        args: {
            form_id: form.id,
            trigger_events: true,
            meta_data_only: 1,
            sql_args: {
                where: [
                    [ 'employee_info.emp_internal_id', 'LIKE', emp_internal_id ]
                ]
            },
            data_preprocessor: function(func_args, response) {
                add_employee_form_listeners(form, response.meta_data);
            }
        }
    };
    args.methods.push(form_args);
    //
    if (emp_internal_id) {
        //
        // adding the form population method
        form_args.args.meta_data_only = undefined;
        //
        // setting form header
        row_data = document.getElementById(row_id).dataset;
        msg = 'Modfiying Employee: {emp_first_name} {emp_last_name}';
        document.getElementById('form-header').textContent = msg.format(row_data);
        callback = function() {
            //
            // adding buttons
            mod_button = document.createElementWithAttr('BUTTON', {
                id: 'submit-employee-form',
                type: 'button'
            });
            mod_button.addTextNode('Modify Employee');
            mod_button.addEventListener(
                'click',
                validate_employee_form.bind(null, form, 'modification')
            );
            //
            del_button = mod_button.cloneNode();
            del_button.id = 'del-button';
            del_button.addTextNode('Delete Employee');
            del_button.addEventListener(
                'click',
                validate_employee_form.bind(null, form, 'deletion')
            );
            //
            res_button = mod_button.cloneNode();
            res_button.id = 'res-button';
            res_button.addTextNode('Reinstate Employee');
            res_button.addEventListener(
                'click',
                validate_employee_form.bind(null, form, 'reinstatement')
            );
            form.addNodes([ mod_button, del_button, res_button ]);
            //
            // manipulating buttons
            if (document.getElementById('emp-status').value !== 'active') {
                AFW_HUB.Utilities.add_class('hidden-elm', del_button.id);
            } else {
                AFW_HUB.Utilities.add_class('hidden-elm', res_button.id);
            }
        };
    } else {
        //
        // setting form header
        document.getElementById('form-header').textContent = 'Creating New Employee';
        document.getElementById('emp-id').disabled = false;
    }
    //
    AFW_HUB.FormUtil.populate_multiple_containers(args, callback);
}
////////////////////////////////////////////////////////////////////////////
/////////////////////////// Form Submission ////////////////////////////////
//
// validates the employee form
function validate_employee_form(form, act) {
    //
    var errors = false;
    //
    // checking if the emp id is unique
    // recursion allows for it being it's own callback
    if (!this) {
        var args = [
            document.getElementById('emp-id'),
            document.getElementById('emp-internal-id'),
            'employee_info',
            null,
            validate_employee_form.bind(window, form, act)
        ];
        AFW_HUB.FormUtil.check_unique.apply(null, args);
        return false;
    }
    errors = AFW_HUB.FormUtil.auto_validate(form);
    //
    if (errors) {
        return false;
    }
    //
    submit_employee_form(form, act);
}
//
// submits the employee form
function submit_employee_form(form, act) {
    var form_values = AFW_HUB.FormUtil.get_all_form_values(form),
        cont = confirm('Confirm ' + act + ' of employee.'),
        callback = reset_employee_form.bind(null, act),
        args = [ form.name, form_values, callback ];
    //
    if (!cont) {
        return;
    }
    //
    // action based employee status
    if (act === 'creation') {
        form_values.emp_status = 'active';
        delete form_values.emp_internal_id;
    } else if (act === 'deletion') {
        form_values.emp_status = 'inactive';
    } else if (act === 'reinstatement') {
        form_values.emp_status = 'active';
    }
    //
    AFW_HUB.Ajax.submit_form_values.apply(null, args);
}
//
//
function reset_employee_form(act) {
    //
    alert('Successful ' + act + ' of Employee.');
    //
    document.getElementById('employee-table').dispatchPrimaryEvent();
    document.getElementById('form-header').textContent = '';
    document.getElementById('form-div').removeAll();
}
