/* global AFW_HUB */
/*eslint-disable camelcase */
/*eslint-disable no-alert */
/*eslint-disable no-use-before-define */
/*eslint-disable global-strict */
////////////////////////////////////////////////////////////////////////////////
//////////////       This file holds the functions that are          ///////////
//////////////       associated with updating meta and info tables   ///////////
////////////////////////////////////////////////////////////////////////////////
'use strict';
//
///////////////////////// Page Generation Functions ///////////////////////////
//
// sets up the page to modify meta data or update an info table or meta data
function table_maintenance_page() {
    var url_data = AFW_HUB.Navigation.parse_url(),
        nav_container = document.getElementById('nav-container'),
        button = document.createElementWithAttr('BUTTON', { class: 'big' });
    //
    document.getElementById('nav-header').textContent = 'Table Maintenance';
    //
    button.textContent = 'Update Info Table';
    button.addEventListener('click', update_info_tables.bind(null));
    nav_container.appendChild(button);
    //
    button = button.cloneNode();
    button.textContent = 'Update Column Meta Data';
    button.addEventListener('click', update_column_meta_data);
    nav_container.appendChild(button);
    //
    button = button.cloneNode();
    button.textContent = 'Update Form Meta Data';
    button.addEventListener('click', update_form_meta_data);
    nav_container.appendChild(button);
    //
    button = button.cloneNode();
    button.textContent = 'Update Table Meta Data';
    button.addEventListener('click', update_table_meta_data);
    nav_container.appendChild(button);
    //
    button = button.cloneNode();
    button.textContent = 'Update HTML Table Presets';
    button.addEventListener('click', update_html_table_presets);
    nav_container.appendChild(button);
    //
    if (url_data.gen_suggestions === 'true') {
        update_info_tables();
    }
}
//
// sets up the page to update an info table
function update_info_tables() {
    //
    var url_data = AFW_HUB.Navigation.parse_url(),
        fieldset = document.createElementWithAttr('FIELDSET', {}),
        legend = document.createElement('LEGEND'),
        placeholder = document.createElementWithAttr('H4', { id: 'table-select' }),
        input = document.createElementWithAttr('INPUT', { type: 'hidden' }),
        button;
    reset_table_maintenance();
    //
    // setting up the page
    document.getElementById('table-div').appendChild(document.createElement('BR'));
    document.getElementById('input-div').appendChild(fieldset);
    document.getElementById('table-div').appendChild(document.createElement('BR'));
    fieldset.style.width = '75%';
    legend.textContent = 'Select Table';
    placeholder.textContent = 'Loading . . . ';
    input.id = 'table-selected';
    fieldset.appendChild(legend);
    fieldset.appendChild(placeholder);
    fieldset.appendChild(input);
    list_all_info_tables(fieldset);
    //
    //
    // creating refinement table
    fieldset = fieldset.cloneNode();
    fieldset.id = 'table-refinement';
    legend = legend.cloneNode();
    AFW_HUB.Utilities.add_class('hidden-elm', fieldset);
    legend.textContent = 'Table Refinement';
    fieldset.appendChild(legend);
    create_info_table_refinement(fieldset);
    //
    // adding buttons
    button = document.createElementWithAttr('BUTTON', { id: 'update-table' });
    button.addEventListener('click', create_info_table.bind(null, 1, '', ''));
    button.textContent = 'Update Table';
    fieldset.appendChild(button);
    //
    button = document.createElementWithAttr('BUTTON', { id: 'clear-inputs' });
    button.addEventListener('click', reset_info_table_refinement);
    button.textContent = 'Clear Inputs';
    fieldset.appendChild(button);
    //
    button = document.createElementWithAttr('BUTTON', { id: 'create-new-entry' });
    button.textContent = 'Create New Entry';
    fieldset.appendChild(button);
    //
    fieldset.appendChild(document.createElement('BR'));
    fieldset.addTextNode(
        '** Mouse over table header cell to view actual column name'
    );
    document.getElementById('input-div').appendChild(fieldset);
    //
    if (url_data.gen_suggestions) {
        gen_suggestions_table(url_data.status);
    }
}
//
// sets up the page to update the column meta data
function update_column_meta_data() {
    //
    var table_func = create_col_meta_data_table.bind(null, 1, 'column_name', 'ASC'),
        input_div = document.getElementById('input-div'),
        table_div = document.getElementById('table-div'),
        fieldset = document.createElementWithAttr('FIELDSET', {
            id: 'refine-params'
        }),
        button = document.createElementWithAttr('BUTTON', { type: 'button' }),
        toggle_btn = button.cloneNode(),
        toggle;
    //
    reset_table_maintenance();
    AFW_HUB.Utilities.add_class('hidden-elm', table_div);
    toggle = toggle_view_element_button.bind(
        null,
        toggle_btn,
        table_div,
        'Hide Table',
        'Show Table'
    );
    toggle();
    //
    button.textContent = 'Create New Entry';
    button.addEventListener('click', function() {
        AFW_HUB.Utilities.add_class('hidden-elm', table_div);
        mod_col_meta_data_entry.call(null, null, null, undefined);
        toggle_btn.value = 'update-button';
        toggle();
    });
    toggle_btn.addEventListener('click', toggle);
    //
    // adding nodes to input div
    input_div.addNodes([ fieldset, button, toggle_btn ]);
    create_col_meta_data_refinement(fieldset, table_func);
    table_func();
}
//
// sets up the page to update column meta data
function update_form_meta_data() {
    //
    var table_func = create_form_meta_data_table.bind(null, 1, 'column_name', 'ASC'),
        input_div = document.getElementById('input-div'),
        table_div = document.getElementById('table-div'),
        fieldset = document.createElementWithAttr('FIELDSET', {
            id: 'refine-params'
        }),
        label = document.createElement('LABEL'),
        load_error = label.cloneNode(),
        input = document.createElementWithAttr('INPUT', {
            id: 'form-name',
            type: 'text'
        }),
        button = document.createElementWithAttr('BUTTON', { type: 'button' }),
        toggle_btn = button.cloneNode(),
        form_func,
        toggle;
    //
    reset_table_maintenance();
    AFW_HUB.Utilities.add_class('hidden-elm', table_div);
    toggle = toggle_view_element_button.bind(
        null,
        toggle_btn,
        table_div,
        'Hide Table',
        'Show Table'
    );
    toggle_btn.id = 'toggle-form-meta-table';
    toggle_btn.value = 'update-button';
    toggle_btn.addEventListener('click', toggle);
    toggle();
    //
    // creating a load form input field
    form_func = function form_func() {
        var dummy_elm = document.createElement('DIV'),
            form_name = document.getElementById('form-name').value,
            callback = setup_form_meta_data_entry.bind(null, form_name);
        AFW_HUB.FormUtil.load_html_form(form_name, dummy_elm, callback);
    };
    //
    label.textContent = 'Load a form to begin';
    fieldset.addNodes([ label, document.createElement('BR') ]);
    //
    label = label.cloneNode();
    label.textContent = 'Form Name: ';
    AFW_HUB.Utilities.add_class('error-msg', load_error);
    AFW_HUB.Utilities.add_class('hidden-elm', load_error);
    load_error.id = 'form-load-error';
    load_error.textContent = 'Form Not Found';
    button.textContent = 'Load Form';
    button.addEventListener('click', form_func);
    fieldset.addNodes([
        label,
        input,
        button,
        load_error,
        document.createElement('BR')
    ]);
    //
    label = label.cloneNode();
    label.textContent = 'Restrict Columns to Form:';
    input = input.cloneNode();
    input.id = 'restrict-columns';
    input.type = 'checkbox';
    input.addEventListener('click', table_func);
    fieldset.addNodes([ label, input, document.createElement('HR') ]);
    //
    // adding nodes to input div
    input_div.addNodes([ fieldset, toggle_btn ]);
    create_form_meta_data_refinement(fieldset, table_func);
    table_func();
}
//
// sets up the page to update table meta data
function update_table_meta_data() {
    //
    var table_func = create_table_meta_data_table.bind(
        null,
        1,
        'column_name',
        'ASC'
    ),
        input_div = document.getElementById('input-div'),
        table_div = document.getElementById('table-div'),
        meta_table_div = document.createElementWithAttr('DIV', {
            id: 'meta-table-div'
        }),
        disp_table_div = document.createElementWithAttr('DIV', {
            id: 'disp-table-div'
        }),
        fieldset = document.createElementWithAttr('FIELDSET', {
            id: 'refine-params'
        }),
        label = document.createElement('LABEL'),
        select = document.createElementWithAttr('SELECT', { type: 'text' }),
        input = document.createElementWithAttr('INPUT', { type: 'text' }),
        button = document.createElementWithAttr('BUTTON', { type: 'button' }),
        header = document.createElement('H4'),
        toggle_meta_btn = button.cloneNode(),
        toggle_disp_btn = button.cloneNode(),
        toggle;
    //
    // clearing page and adding new elements
    reset_table_maintenance();
    table_div.safeAppendChild(meta_table_div);
    table_div.safeAppendChild(document.createElement('BR'));
    table_div.safeAppendChild(disp_table_div);
    header.textContent = 'Click on a table row to add it to the form:';
    meta_table_div.appendChild(header);
    header = header.cloneNode();
    header.textContent = 'Display table based on current meta data in form:';
    disp_table_div.appendChild(header);
    disp_table_div.appendChild(document.createElement('BR'));
    label = label.cloneNode();
    label.textContent = 'Display for page:';
    select = select.cloneNode();
    select.id = 'display-table-use-on-page';
    disp_table_div.addNodes([ label, select, document.createElement('BR') ]);
    disp_table_div.safeAppendChild(document.createElement('BR'));
    //
    // setting up the toggle buttons
    AFW_HUB.Utilities.add_class('hidden-elm', meta_table_div);
    toggle = toggle_view_element_button.bind(
        null,
        toggle_meta_btn,
        meta_table_div,
        'Hide Meta Table',
        'Show Meta Table'
    );
    toggle_meta_btn.id = 'toggle-table-meta-table';
    toggle_meta_btn.value = 'update-button';
    toggle_meta_btn.addEventListener('click', toggle);
    toggle();
    //
    AFW_HUB.Utilities.add_class('hidden-elm', disp_table_div);
    toggle = toggle_view_element_button.bind(
        null,
        toggle_disp_btn,
        disp_table_div,
        'Hide Display Table',
        'Show Display Table'
    );
    toggle_disp_btn.id = 'toggle-display-table';
    toggle_disp_btn.value = 'update-button';
    toggle_disp_btn.addEventListener('click', toggle);
    toggle();
    //
    label = label.cloneNode();
    label.textContent = 'Set an HTML table name to begin';
    fieldset.addNodes([ label, document.createElement('BR') ]);
    //
    // adding table selection elements
    label = label.cloneNode();
    input = input.cloneNode();
    select = select.cloneNode();
    label.textContent = 'HTML table Name: ';
    input.id = 'new-html-table-name';
    select.id = 'html-table-name';
    toggle = AFW_HUB.FormUtil.show_other.bind(null, select, input);
    select.addEventListener('change', toggle);
    button.textContent = 'Set HTML Table';
    button.addEventListener(
        'click',
        setup_table_meta_data_entry.bind(null, undefined, undefined)
    );
    fieldset.addNodes([ label, select, button, document.createElement('BR') ]);
    // setting up an input to handle "new" tables
    fieldset.addNodes([ label.cloneNode(), input, document.createElement('BR') ]);

    input = input.cloneNode();
    // cloning here to prevent checkbox getting hidden
    select.dispatchPrimaryEvent();
    //
    label = label.cloneNode();
    label.textContent = 'Restrict Columns to HTML Table:';
    input.id = 'restrict-columns';
    input.type = 'checkbox';
    input.addEventListener('click', table_func);
    fieldset.addNodes([ label, input, document.createElement('BR') ]);
    //
    // adding option to sort form by column name, display or query order
    label = label.cloneNode();
    label.textContent = 'Initally Sort Form By: ';
    select = select.cloneNode();
    select.id = 'sort-form-by';
    select.add_children([
        {elm: 'OPTION', value: 'display_order', textNode: 'Display Order'},
        {elm: 'OPTION', value: 'query_order', textNode: 'Query Order'},
        {elm: 'OPTION', value: 'column_name', textNode: 'Column Name'}
    ]);
    fieldset.addNodes([ label, select, document.createElement('HR') ]);
    //
    // adding nodes to input div
    input_div.addNodes([ fieldset, toggle_meta_btn, toggle_disp_btn ]);
    create_table_meta_data_refinement(fieldset, table_func);
}
//
// sets up the page to update table presets
function update_html_table_presets() {
    //
    var table_func = create_table_presets_table.bind(null, 1, 'preset_name', 'ASC'),
        input_div = document.getElementById('input-div'),
        table_div = document.getElementById('table-div'),
        fieldset = document.createElementWithAttr('FIELDSET', {
            id: 'refine-params'
        }),
        button = document.createElementWithAttr('BUTTON', { type: 'button' }),
        toggle_btn = button.cloneNode(),
        toggle;
    //
    reset_table_maintenance();
    AFW_HUB.Utilities.add_class('hidden-elm', table_div);
    toggle = toggle_view_element_button.bind(
        null,
        toggle_btn,
        table_div,
        'Hide Table',
        'Show Table'
    );
    toggle();
    //
    button.textContent = 'Create New Preset';
    button.addEventListener('click', function() {
        AFW_HUB.Utilities.add_class('hidden-elm', table_div);
        mod_table_preset_entry.call(null, null, null, undefined);
        toggle_btn.value = 'update-button';
        toggle();
    });
    toggle_btn.addEventListener('click', toggle);
    //
    // adding nodes to input div
    input_div.addNodes([ fieldset, button, toggle_btn ]);
    create_table_presets_refinement(fieldset, table_func);
    table_func();
}
//
// clears the maintenance page
function reset_table_maintenance() {
    //
    document.getElementById('input-div').removeAll();
    document.getElementById('table-header').textContent = '';
    document.getElementById('table-div').removeAll();
    document.getElementById('content-header').textContent = '';
    document.getElementById('content-div').removeAll();
}
//
///////////////////////////////////////////////////////////////////////////////
///////////////////////////// Secondary Functions /////////////////////////////
//
// this creates the table select box on te table_maintenance page
function list_all_info_tables(output_div) {
    var sql_args,
        callback,
        select_children = [
            {
                elm: 'option',
                value: '',
                disabled: true,
                selected: true,
                textNode: 'Select a Table'
            }
        ];
    //
    sql_args = {
        cmd: 'SELECT',
        cols: [ 'TABLE_NAME' ],
        table: 'INFORMATION_SCHEMA.TABLES',
        where: [
            [ 'TABLE_SCHEMA', 'LIKE', 'afwg_hub_misc' ],
            [ 'TABLE_TYPE', 'LIKE', 'BASE_TABLE' ]
        ]
    };
    //
    //
    callback = function(response) {
        var tables = response.tables,
            select_element = document.createElement('SELECT'),
            option,
            i;
        select_element.id = 'table-select';
        select_element.multiple = true;
        select_element.style.height = '10em';
        select_element.addEventListener('change', reset_info_table_refinement);
        select_element.addEventListener('change', function() {
            document.getElementById('content-header').textContent = '';
            document.getElementById('content-div').removeAll();
        });
        select_element.addEventListener(
            'change',
            create_info_table.bind(null, 1, '', '')
        );
        for (i = 0; i < tables.length; i++) {
            option = {
                elm: 'option',
                value: tables[i].TABLE_NAME,
                textNode: tables[i].TABLE_NAME
            };
            select_children.push(option);
        }
        select_element.add_children(select_children);
        output_div.safeAppendChild(select_element);
    };
    //
    AFW_HUB.Ajax.fetch_db([ sql_args ], [ 'tables' ], 'misc_database', callback);
}
//
// fetches data to build the misc_table update form
function mod_table_entry(table_name, row_id) {
    //
    var meta_args, row_data = {}, callback;
    document.getElementById('table-selected').value = table_name;
    //
    meta_args = {
        cmd: 'SELECT',
        table: 'column_meta_data',
        where: [
            [ 'column_type', 'REGEXP', 'static' ],
            [ 'in_table', 'LIKE', table_name ]
        ],
        order_by: [ [ 'column_name', 'ASC' ] ]
    };
    //
    if (row_id !== '') {
        row_data = document.getElementById(row_id).dataset;
    }
    callback = create_info_table_edit_form.bind(null, table_name, row_data);
    AFW_HUB.Ajax.fetch_db([ meta_args ], [ 'meta_data' ], 'meta_database', callback);
}
//
// generates the form to update a column meta data entry
function mod_col_meta_data_entry(row_id, internal_id, form) {
    //
    var content_div = document.getElementById('content-div'),
        submit_button = document.getElementById('submit-form'),
        header = 'Creating a new Column Meta Data Entry',
        row_data, args, form_args, callback;
    row_data = row_id ? document.getElementById(row_id).dataset : {};
    //
    // loading form
    if (form === undefined) {
        callback = mod_col_meta_data_entry.bind(null, row_id, internal_id);
        form = 'column_meta_data_form';
        AFW_HUB.FormUtil.load_html_form(form, content_div, callback);
        return;
    }
    //
    // setting up args to populate dropboxes and form
    form_args = {
        form_id: form.id,
        trigger_events: true,
        meta_data_only: 1,
        sql_args: {
            where: [
                ['column_meta_data.internal_id', 'LIKE', internal_id]
            ]
        },
        data_preprocessor: function(args, response) {
            var event_args = {meta_array: response.meta_data},
                sub_func = submit_col_meta_data_form.bind(null, form);
            AFW_HUB.FormUtil.add_standard_event_listeners(form, event_args);
            submit_button.addEventListener('click', sub_func);
        }
    };
    args = {
        methods: [
            {
                function: AFW_HUB.FormUtil.populate_dropbox_options,
                args: {
                    sql_args: {
                        cmd: 'SELECT',
                        cols: [ 'DISTINCT(`in_database`) AS `_database`' ],
                        table: 'column_meta_data',
                        where: [ [ 'in_database', 'REGEXP', '.+' ] ],
                        order_by: [ [ '_database', 'ASC' ] ]
                    },
                    database: 'meta_database',
                    dropbox_id: 'in-database',
                    text_format: '%_database%',
                    value_format: '%_database%',
                    placeholder: 'Select Database',
                    placeholder_value: '',
                    placeholder_disabled: true,
                    add_opts_val: ['other'],
                    add_opts_text: ['New Database']
                }
            },
            {
                function: AFW_HUB.FormUtil.populate_dropbox_options,
                args: {
                    sql_args: {
                        cmd: 'SELECT',
                        cols: [ 'DISTINCT(`in_table`) AS `_table`' ],
                        table: 'column_meta_data',
                        where: [ [ 'in_table', 'REGEXP', '.+' ] ],
                        order_by: [ [ '_table', 'ASC' ] ]
                    },
                    database: 'meta_database',
                    dropbox_id: 'in-table',
                    text_format: '%_table%',
                    value_format: '%_table%',
                    placeholder: 'Select Table',
                    placeholder_value: '',
                    placeholder_disabled: true,
                    add_opts_val: ['other'],
                    add_opts_text: ['New Table']
                }
            },
            {
                function: AFW_HUB.FormUtil.populate_form,
                args: form_args
            }
        ]
    };
    //
    if (internal_id) {
        header = 'Updating meta data for: {in_database}.{in_table}.{column_name}';
        header = header.format(row_data);
        submit_button.textContent = 'Update Meta Data';
        form_args.meta_data_only = undefined;
    }
    //
    document.getElementById('content-header').textContent = header;
    AFW_HUB.FormUtil.populate_multiple_containers(args);
}
//
// generates the form that will modify form meta data
function setup_form_meta_data_entry(form_name, form) {
    AFW_HUB.FormUtil.update_error_css(!form, 'form-name', 'form-load-error');
    if (!form) {
        return;
    }
    //
    var form_elms = form.allSubNodes(), elm_names = [], i;
    //
    // determining names of elements in the form
    for (i = 0; i < form_elms.length; i++) {
        if (form_elms[i].name && form_elms[i].name !== '') {
            elm_names.push(form_elms[i].name);
        }
    }
    //
    // updating the table to only show columns with those names
    elm_names = elm_names.join(',');
    document.getElementById('restrict-columns').value = elm_names;
    document.getElementById('restrict-columns').dataset.form_name = form_name;
    document.getElementById('restrict-columns').checked = true;
    document.getElementById('restrict-columns').dispatchPrimaryEvent();
    //
    // building form entry table
    build_form_data_entry(form_name);
}
//
// generates the form that will modify table meta data
function setup_table_meta_data_entry(form, response) {
    //
    var html_table_name = document.getElementById('html-table-name').value,
        content_header = document.getElementById('content-header'),
        content_div = document.getElementById('content-div'),
        form_order_col = document.getElementById('sort-form-by').value,
        sql_args,
        callback,
        meta_data,
        elm_names = [],
        i;
    //
    if (html_table_name === 'other') {
        html_table_name = document.getElementById('new-html-table-name').value;
    }
    if (html_table_name.trim() === '') {
        return;
    }
    //
    // loading form
    if (form === undefined) {
        form = 'table_meta_data_entry';
        callback = setup_table_meta_data_entry.bind(null);
        AFW_HUB.FormUtil.load_html_form(form, content_div, callback);
        return;
    }
    //
    // fetching current meta data on the specified table
    if (response === undefined) {
        sql_args = {
            cmd: 'SELECT',
            cols: [
                'column_meta_data.in_database',
                'column_meta_data.in_table',
                'column_meta_data.column_name',
                'column_meta_data.data_type',
                'table_meta_data.*'
            ],
            table: 'column_meta_data',
            inner_join: [
                [
                    'table_meta_data',
                    'column_meta_data.internal_id',
                    'table_meta_data.column_internal_id'
                ]
            ],
            where: [ [ 'html_table', 'LIKE', html_table_name ] ],
            order_by: [
                [ form_order_col, 'ASC' ],
                [ 'table_meta_data.display_order', 'ASC' ],
                [ 'column_meta_data.column_name', 'ASC' ]
            ]
        };
        callback = setup_table_meta_data_entry.bind(null, form);
        AFW_HUB.Ajax.fetch_db(
            [ sql_args ],
            [ 'meta_data' ],
            'meta_database',
            callback
        );
        return;
    }
    //
    // initializing elements
    content_header.textContent = 'Updating table meta data for table: ' +
        html_table_name;
    if (document.getElementById('table-meta-disp-table')) {
        document.getElementById('table-meta-disp-table').remove();
    }
    //
    // processing meta data returned to build form and restrict columns
    meta_data = response.meta_data;
    for (i = 0; i < meta_data.length; i++) {
        elm_names.push(meta_data[i].column_name);
        add_table_meta_row(null, meta_data[i]);
    }
    //
    // adding submission event handler
    document
        .getElementById('submit-form')
        .addEventListener(
            'click',
            submit_table_meta_data_entries.bind(null, html_table_name, form)
        );
    //
    // updating the table to only show columns with those names
    elm_names = elm_names.join(',');
    document.getElementById('restrict-columns').value = elm_names;
    document.getElementById(
        'restrict-columns'
    ).dataset.html_table_name = html_table_name;
    document.getElementById('restrict-columns').checked = true;
    document.getElementById('restrict-columns').dispatchPrimaryEvent();
    //
    // build the display table
    create_table_meta_data_display_table(form);
}
//
// generates the form that will modify a table preset
function mod_table_preset_entry(row_id, internal_id, form) {
    var content_div = document.getElementById('content-div'),
        submit_button = document.getElementById('submit-form'),
        header = 'Creating new preset entry',
        row_data, form_args, dropbox_args, preprocessor, callback;
    row_data = row_id ? document.getElementById(row_id).dataset : {};
    //
    // loading form
    if (!form) {
        callback = mod_table_preset_entry.bind(null, row_id, internal_id);
        form = 'table_preset_form';
        AFW_HUB.FormUtil.load_html_form(form, content_div, callback);
        return;
    }
    //
    // form args pre-processor
    preprocessor = function(args, response) {
        var event_args = {meta_array: response.meta_data},
            elm = document.getElementById('force-html-table'),
            sql_args;
        //
        // adding some static fields to the form data
        if (response.form_data) {
            sql_args = JSON.parse(response.form_data[0].sql_args_json);
            response.form_data[0].group_by = sql_args.group_by || '';
            response.form_data[0].having = sql_args.having || '';
        }
        else {
            response.form_data = [{}];
        }
        //
        AFW_HUB.FormUtil.add_standard_event_listeners(form, event_args);
        elm.dispatchPrimaryEvent();  // dispatched here to sync select and checkbox
        //
        // resets/ builds sql args fieldset
        elm.addEventListener('click', function(checkbox, resp) {
            resp.form_data = [{ html_table: checkbox.value }];
            //
            reset_preset_sql_args();
            if (!checkbox.checked) {
                document.getElementById('sql-args').style.display = 'none';
            } else {
                document.getElementById('sql-args').style.display = '';
                build_preset_table_form(form, resp);
            }
        }.bind(null, elm, response));
        //
        // event handler to add additional where clauses
        elm = document.getElementById('add-new-where');
        elm.addEventListener('click', clone_entry_div.bind(null, 'where-clause'));
        //
        elm = document.getElementById('submit-form');
        elm.addEventListener('click', submit_preset_form_data.bind(null, form));
    };
    //
    // setting up args to fetch data and build form
    form_args = {
        form_id: form.id,
        trigger_events: false,
        meta_data_only: 1,
        sql_args: {
            where: [['table_preset_sql_args.internal_id', 'LIKE', internal_id]]
        },
        data_preprocessor: preprocessor
    };
    //
    dropbox_args = {
        dropbox_id: 'html-table',
        text_format: '%html_table%',
        value_format: '%html_table%',
        placeholder: 'Select an HTML Table',
        placeholder_value: '',
        database: 'meta_database',
        sql_args: {
            cmd: 'SELECT',
            cols: [ 'DISTINCT(`html_table`) AS `html_table`' ],
            table: 'table_meta_data',
            where: [ [ 'html_table', 'REGEXP', '.+' ] ]
        },
        add_callback: function () {
            AFW_HUB.FormUtil.populate_form(form_args);
        }
    };
    //
    // additional setup for modification of an entry
    if (internal_id) {
        header = 'Updating preset {preset_name} for table {html_table}';
        header = header.format(row_data);
        document.getElementById('force-html-table').checked = true;
        document.getElementById('sql-args').style.display = '';
        submit_button.textContent = 'Update Preset';
        form_args.meta_data_only = undefined;
        form_args.add_callback = function (args, form, response) {
            build_preset_table_form(form, response);
        };
    }
    document.getElementById('content-header').textContent = header;
    AFW_HUB.FormUtil.populate_dropbox_options(dropbox_args);
}
//
//
///////////////////////////////////////////////////////////////////////////////
///////////////////////// Table Refinement Functions //////////////////////////
//
// creates the general refinement box for the info tables
function create_info_table_refinement(output_div) {
    var table = document.createElement('TABLE'),
        row = document.createElement('TR'),
        cell = document.createElement('TD'),
        input,
        select,
        elms,
        i;
    //
    // setting initial header cells
    table.style.margin = '0px';
    elms = [
        { elm: 'TH', textNode: 'Column Name' },
        { elm: 'TH', textNode: 'Match Type' },
        { elm: 'TH', textNode: 'Value' }
    ];
    row.add_children(elms);
    table.appendChild(row);
    //
    // defining selection box options and refinement fields
    elms = [
        { elm: 'OPTION', value: 'REGEXP', textNode: 'REGEXP' },
        { elm: 'OPTION', value: 'LIKE', textNode: 'LIKE' },
        { elm: 'OPTION', value: 'NOT REGEXP', textNode: 'NOT REGEXP' }
    ];
    //
    for (i = 1; i < 3; i++) {
        //
        row = row.cloneNode();
        //
        // creating column name input
        cell = cell.cloneNode();
        input = document.createElementWithAttr('INPUT', { id: 'column-name-' + i });
        input.name = input.id;
        cell.appendChild(input);
        row.appendChild(cell);
        //
        // adding match type select
        cell = cell.cloneNode();
        select = document.createElementWithAttr('SELECT', { id: 'match-type-' + i });
        select.name = select.id;
        select.add_children(elms);
        cell.appendChild(select);
        row.appendChild(cell);
        //
        // creating column value input
        cell = cell.cloneNode();
        input = document.createElementWithAttr('INPUT', { id: 'column-value-' + i });
        input.name = input.id;
        cell.appendChild(input);
        row.appendChild(cell);
        //
        table.appendChild(row);
    }
    //
    output_div.appendChild(table);
}
//
// this function clears the table maintenance inputs
function reset_info_table_refinement() {
    //
    document.getElementById('column-name-1').value = '';
    document.getElementById('match-type-1').value = 'REGEXP';
    document.getElementById('column-value-1').value = '';
    document.getElementById('column-name-2').value = '';
    document.getElementById('match-type-2').value = 'REGEXP';
    document.getElementById('column-value-2').value = '';
}
//
// this function adds the column name to the a serch box if the cell is clicked
function column_to_refine_box(col_name) {
    //
    var box1_id = 'column-name-1',
        box2_id = 'column-name-2',
        box1_col = document.getElementById(box1_id).value;
    //
    if (box1_col === '') {
        document.getElementById(box1_id).value = col_name;
    } else {
        document.getElementById(box2_id).value = col_name;
    }
    //
}
//
// provides the standard set of meta data refinement elements
function standard_meta_data_refinement_elms(refine_func) {
    //
    var ref_elms = [
        { elm: 'legend', textNode: 'Selection Parameters' },
        { elm: 'label', textNode: 'Database: ' },
        {
            elm: 'select',
            id: 'refine-in-database',
            name: 'in_database',
            events: [ { event: 'change', function: refine_func } ]
        },
        { elm: 'br' },
        { elm: 'label', textNode: 'Table: ' },
        {
            elm: 'select',
            id: 'refine-in-table',
            name: 'in_table',
            events: [ { event: 'change', function: refine_func } ]
        },
        { elm: 'br' },
        { elm: 'label', textNode: 'Column Name: ' },
        {
            elm: 'input',
            id: 'refine-column-name',
            type: 'text',
            name: 'column_name',
            events: [ { event: 'keyup', function: refine_func } ]
        },
        { elm: 'br' },
        { elm: 'label', textNode: 'Column Type: ' },
        {
            elm: 'input',
            id: 'refine-column_type',
            type: 'text',
            name: 'column_type',
            events: [ { event: 'keyup', function: refine_func } ]
        },
        { elm: 'br' },
        { elm: 'label', textNode: 'Data Type: ' },
        {
            elm: 'input',
            id: 'refine-data-type',
            type: 'text',
            name: 'data_type',
            events: [ { event: 'keyup', function: refine_func } ]
        }
        ],
        database_dropbox_args,
        table_dropbox_args;
    //
    // setting dropbox arguments
    database_dropbox_args = {
        sql_args: {
            cmd: 'SELECT',
            cols: [ 'DISTINCT(`in_database`) AS `_database`' ],
            table: 'column_meta_data',
            where: [ [ 'in_database', 'REGEXP', '.+' ] ],
            order_by: [ [ '_database', 'ASC' ] ]
        },
        database: 'meta_database',
        dropbox_id: 'refine-in-database',
        text_format: '%_database%',
        value_format: '^%_database%$',
        placeholder: 'All',
        placeholder_value: '',
        placeholder_disabled: false
    };
    //
    table_dropbox_args = Object.clone(database_dropbox_args);
    table_dropbox_args.sql_args = {
        cmd: 'SELECT',
        cols: [ 'DISTINCT(`in_table`) AS `_table`' ],
        table: 'column_meta_data',
        where: [ [ 'in_table', 'REGEXP', '.+' ] ],
        order_by: [ [ '_table', 'ASC' ] ]
    };
    table_dropbox_args.dropbox_id = 'refine-in-table';
    table_dropbox_args.text_format = '%_table%';
    table_dropbox_args.value_format = '^%_table%$';
    //
    return {
        ref_elms: ref_elms,
        database_dropbox_args: database_dropbox_args,
        table_dropbox_args: table_dropbox_args
    };
}
//
// creates the column meta data table refinement fields
function create_col_meta_data_refinement(output_elm, refine_func) {
    //
    var refine = standard_meta_data_refinement_elms(refine_func);
    //
    // outputting elements to the DOM
    output_elm.add_children(refine.ref_elms);
    //
    // populating dropboxes
    AFW_HUB.FormUtil.populate_dropbox_options(refine.database_dropbox_args);
    AFW_HUB.FormUtil.populate_dropbox_options(refine.table_dropbox_args);
}
//
// creates the form meta data refinement
function create_form_meta_data_refinement(output_elm, refine_func) {
    //
    var refine = standard_meta_data_refinement_elms(refine_func);
    //
    // outputting elements to the DOM
    output_elm.add_children(refine.ref_elms);
    //
    // populating dropboxes
    AFW_HUB.FormUtil.populate_dropbox_options(refine.database_dropbox_args);
    AFW_HUB.FormUtil.populate_dropbox_options(refine.table_dropbox_args);
}
//
// creates the table_meta_data refinement
function create_table_meta_data_refinement(output_elm, refine_func) {
    //
    var refine = standard_meta_data_refinement_elms(refine_func),
        html_table_dropbox_args;
    //
    // outputting elements to the DOM
    output_elm.add_children(refine.ref_elms);
    //
    // populating dropboxes
    html_table_dropbox_args = {
        sql_args: {
            cmd: 'SELECT',
            cols: [ 'DISTINCT(`html_table`) AS `dist_html_table`' ],
            table: 'table_meta_data',
            where: [ [ 'html_table', 'NOT LIKE', 'NULL' ] ],
            order_by: [ [ 'dist_html_table', 'ASC' ] ]
        },
        database: 'meta_database',
        dropbox_id: 'html-table-name',
        text_format: '%dist_html_table%',
        value_format: '%dist_html_table%',
        placeholder: 'Select an HTML table',
        placeholder_disabled: true,
        add_opts_val: [ 'other' ],
        add_opts_text: [ 'New HTML Table' ]
    };
    AFW_HUB.FormUtil.populate_dropbox_options(html_table_dropbox_args);
    AFW_HUB.FormUtil.populate_dropbox_options(refine.database_dropbox_args);
    AFW_HUB.FormUtil.populate_dropbox_options(refine.table_dropbox_args);
}
//
// creates the table_presets refinement
function create_table_presets_refinement(output_elm, refine_func) {
    //
    var ref_elms = [
        { elm: 'label', textNode: 'HTML Table: ' },
        {
            elm: 'select',
            id: 'refine-html-table',
            name: 'html_table',
            events: [ { event: 'change', function: refine_func } ]
        },
        { elm: 'br' },
        { elm: 'legend', textNode: 'Selection Parameters' },
        { elm: 'label', textNode: 'Preset Name: ' },
        {
            elm: 'input',
            id: 'refine-preset-name',
            type: 'text',
            name: 'preset_name',
            events: [ { event: 'keyup', function: refine_func } ]
        },
        { elm: 'br' },
        { elm: 'label', textNode: 'Use on Pages: ' },
        {
            elm: 'input',
            id: 'refine-use-on-pages',
            type: 'text',
            name: 'use_on_pages',
            events: [ { event: 'keyup', function: refine_func } ]
        }
        ],
        html_table_dropbox_args = {
            sql_args: {
                cmd: 'SELECT',
                cols: [ 'DISTINCT(`html_table`) AS `_html_table`' ],
                table: 'table_preset_sql_args',
                where: [ [ 'html_table', 'REGEXP', '.+' ] ],
                order_by: [ [ '_html_table', 'ASC' ] ]
            },
            database: 'meta_database',
            dropbox_id: 'refine-html-table',
            text_format: '%_html_table%',
            value_format: '^%_html_table%$',
            placeholder: 'All',
            placeholder_value: '',
            placeholder_disabled: false
        };
    //
    output_elm.add_children(ref_elms);
    AFW_HUB.FormUtil.populate_dropbox_options(html_table_dropbox_args);
}
//
///////////////////////////////////////////////////////////////////////////////
///////////////////////// Table Generation Functions //////////////////////////
//
// creates the selected table using the meta_data and its data
function create_info_table(page, sort_col, sort_dir) {
    //
    // creating argument objects
    var table_args,
        data_sql_args,
        meta_sql_args,
        sql_arr,
        key_arr,
        callback,
        table_name = document.getElementById('table-select').value,
        button = document.getElementById('create-new-entry').cloneNode(true),
        ref_div = document.getElementById('table-refinement'),
        filter_data = AFW_HUB.FormUtil.get_all_form_values(ref_div);
    //
    // updating button and making refinement visible
    AFW_HUB.Utilities.remove_class('hidden-elm', 'table-refinement');
    button.addEventListener('click', mod_table_entry.bind(null, table_name, ''));
    document.getElementById('table-refinement').safeAppendChild(button);
    //
    // getting page elements
    if (table_name === '') {
        alert('No Table Selected.');
        return;
    }
    //
    // setting up SQL generation args
    data_sql_args = { cmd: 'SELECT', table: table_name, where: [] };
    if (filter_data['column-name-1'] !== '') {
        filter_data['column-name-1'] = '`{}`'.format(filter_data['column-name-1']);
        filter_data['column-value-1'] = filter_data['column-value-1'] || '.*';
        data_sql_args.where.push([
            filter_data['column-name-1'],
            filter_data['match-type-1'],
            filter_data['column-value-1']
        ]);
    }
    if (filter_data['column-name-2'] !== '') {
        filter_data['column-name-2'] = '`{}`'.format(filter_data['column-name-2']);
        filter_data['column-value-2'] = filter_data['column-value-2'] || '.*';
        data_sql_args.where.push([
            filter_data['column-name-2'],
            filter_data['match-type-2'],
            filter_data['column-value-2']
        ]);
    }
    //
    if (sort_col !== '') {
        data_sql_args.order_by = [ [ sort_col, sort_dir ] ];
    }
    //
    meta_sql_args = {
        cmd: 'SELECT',
        table: 'afwg_hub_meta_data.column_meta_data',
        where: [ [ 'in_table', 'LIKE', table_name ] ]
    };
    //
    // building table args
    table_args = {
        //data_sql_args: data_sql_args,
        //meta_sql_args: meta_sql_args,
        //database: 'misc_database',
        table_output_id: 'table-div',
        table_attr: { id: 'db-misc-table' },
        row_id_prefix: 'tm-row-',
        row_onclick: [ { func: mod_table_entry, args: [ table_name, '%row_id%' ] } ],
        head_row_args: {
            sortable: true,
            sort_col: sort_col,
            sort_dir: sort_dir,
            sort_onclick: [
                {
                    func: create_info_table,
                    args: [ 1, '%column_name%', '%sort_dir%' ]
                }
            ],
            tooltip: {
                elm: 'SPAN',
                class: 'tooltip',
                textNode: '{column_name}',
                onclick: [
                    { func: column_to_refine_box, args: [ '%column_name%' ] }
                ]
            }
        },
        page_nav_args: {
            curr_page: page,
            sort_col: sort_col,
            sort_dir: sort_dir,
            tot_pages_shown: 9,
            num_per_page: 10,
            page_nav_div_attr: { id: 'table-page-nav' },
            id_prefix: 'tm',
            link_onclick: [
                { func: create_info_table, args: [ '%page%', sort_col, sort_dir ] }
            ]
        },
        regen_function: create_info_table.bind(null, page, sort_col, sort_dir)
    };
    //
    sql_arr = [ data_sql_args, meta_sql_args ];
    key_arr = [ 'table_data', 'meta_data' ];
    callback = function(response) {
        AFW_HUB.TableUtil.create_standard_table(table_args, response);
    };
    //
    AFW_HUB.Ajax.fetch_db(sql_arr, key_arr, 'misc_database', callback);
}
//
// this makes the suggestion table when the link was clicked
function gen_suggestions_table(status) {
    //
    // initializing mutation observer
    var observer = new MutationObserver(function(mutations) {
        mutations.forEach(check_mutation);
    });
    //
    // addng values to refine inputs
    document.getElementById('column-name-1').value = 'suggestion_status';
    document.getElementById('column-value-1').value = status;
    //
    // tracking page mutations to ensure requried elements have been created
    observer.observe(document, {
        childList: true,
        subtree: true,
        attributes: false,
        characterData: false
    });
    //
    // creating function to execute on every mutation record
    function check_mutation(record) {
        //
        var node_list = record.addedNodes, event, i;
        for (i = 0; i < node_list.length; i++) {
            if (node_list[i].id === 'table-select') {
                observer.disconnect();
                //
                // sending event to trigger table generation
                node_list[i].value = 'suggestions';
                event = document.createEvent('HTMLEvents');
                event.initEvent('click', true, false);
                document.getElementById('update-table').dispatchEvent(event);
            }
        }
    }
}
//
// provides the standard set of table args for a meta data table
function standard_meta_data_table_args(table_func, page, sort_col, sort_dir) {
    var data_args, table_args;
    //
    // building SQL arg object
    data_args = {
        table: 'column_meta_data',
        where: [],
        order_by: [ [ sort_col, sort_dir ], [ 'column_name', 'ASC' ] ]
    };
    AFW_HUB.TableUtil.get_table_inputs(
        data_args,
        document.getElementById('refine-params')
    );
    //
    table_args = {
        table_name: 'column_meta_data_selection',
        database: 'meta_database',
        data_sql_args: data_args,
        table_output_id: 'table-div',
        table_attr: { id: 'col-meta-table' },
        row_id_prefix: 'cmd-row-',
        head_row_args: {
            sortable: true,
            sort_col: sort_col,
            sort_dir: sort_dir,
            sort_onclick: [
                { func: table_func, args: [ 1, '%column_name%', '%sort_dir%' ] }
            ]
        },
        page_nav_args: {
            curr_page: page,
            tot_pages_shown: 9,
            num_per_page: 10,
            page_nav_div_attr: { id: 'col-meta-table-page-nav' },
            id_prefix: 'col-meta-',
            link_onclick: [
                { func: table_func, args: [ '%page%', sort_col, sort_dir ] }
            ]
        }
    };
    //
    return table_args;
}
//
// creates a column meta data table
function create_col_meta_data_table(page, sort_col, sort_dir) {
    var table_func = create_col_meta_data_table,
        args = [ table_func, page, sort_col, sort_dir ],
        table_args = standard_meta_data_table_args.apply(null, args);
    //
    table_args.row_onclick = [
        { func: mod_col_meta_data_entry, args: [ '%row_id%', '%internal_id%', undefined ] }
    ];
    //
    AFW_HUB.TableUtil.create_standard_table(table_args);
}
//
// creates the form meta data column selection table
function create_form_meta_data_table(page, sort_col, sort_dir) {
    var table_func = create_form_meta_data_table,
        args = [ table_func, page, sort_col, sort_dir ],
        table_args = standard_meta_data_table_args.apply(null, args),
        restrict = document.getElementById('restrict-columns'),
        sql_args = Object.clone(table_args.data_sql_args);
    //
    table_args.data_sql_args.cols = [ 'column_meta_data.*' ];
    table_args.row_onclick = [ { func: add_form_meta_row, args: [ '%row_id%' ] } ];
    //
    // restricting columns to those specific to the form if desired
    if (restrict.checked) {
        // filtering main query by form column names
        table_args.data_sql_args.where.push([
            'column_name',
            'IN',
            restrict.value.split(',')
        ]);
        //
        // using union statement to pull out any columns associated by the form name
        sql_args.inner_join = [
            [
                'afwg_hub_meta_data.form_meta_data',
                'column_meta_data.internal_id',
                'form_meta_data.column_internal_id'
            ]
        ];
        sql_args.where.push([
            'form_meta_data.form_name',
            'LIKE',
            restrict.dataset.form_name
        ]);
        table_args.data_sql_args.union = [ sql_args ];
    }
    //
    AFW_HUB.TableUtil.create_standard_table(table_args);
}
//
// creates the table meta data column selection table
function create_table_meta_data_table(page, sort_col, sort_dir) {
    var table_func = create_table_meta_data_table,
        args = [ table_func, page, sort_col, sort_dir ],
        table_args = standard_meta_data_table_args.apply(null, args),
        restrict = document.getElementById('restrict-columns'),
        sql_args = Object.clone(table_args.data_sql_args);
    //
    table_args.table_output_id = 'meta-table-div';
    table_args.data_sql_args.cols = [ 'column_meta_data.*' ];
    table_args.row_onclick = [ { func: add_table_meta_row, args: [ '%row_id%' ] } ];
    //
    // restricting columns to those specific to the form if desired
    if (restrict.checked) {
        // filtering main query by form column names
        table_args.data_sql_args.where.push([
            'column_name',
            'IN',
            restrict.value.split(',')
        ]);
        //
        // using union statement to pull out any columns associated by the html table name
        sql_args.inner_join = [
            [
                'afwg_hub_meta_data.table_meta_data',
                'column_meta_data.internal_id',
                'table_meta_data.column_internal_id'
            ]
        ];
        sql_args.where.push([
            'table_meta_data.html_table',
            'LIKE',
            restrict.dataset.html_table_name
        ]);
        table_args.data_sql_args.union = [ sql_args ];
    }
    //
    AFW_HUB.TableUtil.create_standard_table(table_args);
}
//
// creates the table meta data display table
function create_table_meta_data_display_table(form) {
    var table_func = create_table_meta_data_display_table,
        args = [ table_func, 1, '', '' ],
        table_args = standard_meta_data_table_args.apply(null, args),
        rows = form.querySelectorAll('TR'),
        disp_div = document.getElementById('disp-table-div'),
        page_select = document.getElementById('display-table-use-on-page'),
        page_pat = page_select.value || '.*',
        option = document.createElement('OPTION'),
        options = [],
        meta_data = [],
        table_data = [],
        response,
        data,
        i,
        page;
    //
    // pulling meta data from form
    page_pat = new RegExp(page_pat);
    for (i = 1; i < rows.length; i++) {
        data = rows[i].dataset;
        data = Object.clone(data);
        Object.merge(data, AFW_HUB.FormUtil.get_all_form_values(rows[i]));
        data.display_order = Number(data.display_order);
        //
        data.use_on_pages = data.use_on_pages.replace(/(^%)|(%$)/g, '');
        options.push.apply(options, data.use_on_pages.split('%'));
        //
        if (!page_pat.test(data.use_on_pages)) {
            continue;
        } else if (data.column_usage && !data.column_usage.match(/DISPLAY|ALWAYS/)) {
            continue;
        } else {
            meta_data.push(data);
        }
        //
        // setting dummy data based on data type
        if (data.data_type.match('int|float|monetary|round|percent')) {
            table_data[data.column_name] = Math.random() * 100 * Math.random();
        } else if (data.data_type.match('bool')) {
            table_data[data.column_name] = Math.random() > 0.47;
        } else if (data.data_type.match('text')) {
            table_data[data.column_name] = 'Lorem ipsum dolor sit amet, ';
            table_data[data.column_name] += 'consectetur adipiscing elit, ';
            table_data[data.column_name] += 'sed do eiusmod tempor.';
        } else {
            table_data[data.column_name] = 'lorem ipsum';
        }
    }
    //
    // determining unique pages from options array
    options.sort();
    options[options.length] = {};
    for (i = 0; i < options.length - 1; i++) {
        options[options.length - 1][options[i]] = 1;
    }
    options = options[options.length - 1];
    //
    // setting up the page select
    page_select = page_select.cloneNode();
    for (page in options) {
        option = option.cloneNode();
        option.value = '(^|%){}(%|$)'.format(page);
        option.textContent = page;
        page_select.appendChild(option);
    }
    disp_div.safeAppendChild(page_select);
    page_select.value = page_pat.source;
    page_select.addEventListener(
        'change',
        create_table_meta_data_display_table.bind(null, form)
    );
    // sorting by order index, ascending
    meta_data.sort(function(col1, col2) {
        return col1.display_order > col2.display_order;
    });
    //
    // configuring the table generation args
    args = {
        table_output_id: disp_div.id,
        table_attr: { id: 'table-meta-disp-table' },
        regen_function: create_table_meta_data_display_table.bind(null, form),
        no_page_nav: true,
        head_row_args: { sortable: false }
    };
    Object.merge(table_args, args);
    response = { table_data: [ table_data ], meta_data: meta_data };
    //
    AFW_HUB.TableUtil.create_standard_table(table_args, response);
}
//
// creates the table presets table
function create_table_presets_table(page, sort_col, sort_dir) {
    var table_func = create_table_presets_table,
        params_container = document.getElementById('refine-params'),
        table_args = {
            table_name: 'table_presets_table',
            database: 'meta_database',
            data_sql_args: {
                table: 'table_preset_sql_args',
                where: [],
                order_by: [ [ sort_col, sort_dir ], [ 'preset_name', 'ASC' ] ],
                group_by: 'table_preset_sql_args.internal_id'
            },
            table_output_id: 'table-div',
            table_attr: { id: 'presets-table' },
            row_id_prefix: 'pt-row-',
            row_onclick: [
                {
                    func: mod_table_preset_entry,
                    args: [ '%row_id%', '%internal_id%', undefined ]
                }
            ],
            head_row_args: {
                sortable: true,
                sort_col: sort_col,
                sort_dir: sort_dir,
                sort_onclick: [
                    { func: table_func, args: [ 1, '%column_name%', '%sort_dir%' ] }
                ]
            },
            page_nav_args: {
                curr_page: page,
                tot_pages_shown: 9,
                num_per_page: 10,
                page_nav_div_attr: { id: 'presets-table-page-nav' },
                link_onclick: [
                    { func: table_func, args: [ '%page%', sort_col, sort_dir ] }
                ]
            }
        };
    //
    AFW_HUB.TableUtil.get_table_inputs(table_args.data_sql_args, params_container);
    AFW_HUB.TableUtil.create_standard_table(table_args);
}
