/* global AFW_HUB */
/*eslint-disable camelcase */
/*eslint-disable no-alert */
/*eslint-disable no-use-before-define */
/*eslint-disable global-strict */
////////////////////////////////////////////////////////////////////////////////
//////////////       This file holds the functions that are          ///////////
//////////////       associated with updating meta and info tables   ///////////
////////////////////////////////////////////////////////////////////////////////
'use strict';
//
/////////////////////////// Info Table Maintenance Form ///////////////////////
//
// creates the edit table row form
function create_info_table_edit_form(table_name, row_data, response) {
    //
    var meta_data = response.meta_data,
        form = document.createElementWithAttr('FORM', { id: 'update-table-data' }),
        fieldset = document.createElement('FIELDSET'),
        legend = document.createElement('LEGEND'),
        br = document.createElement('BR'),
        label = document.createElementWithAttr('LABEL', {
            style: { width: '15rem' }
        }),
        skip_label = document.createElementWithAttr('LABEL', {
            style: { display: 'inline' }
        }),
        force_label = document.createElementWithAttr('LABEL', {
            style: { display: 'inline' }
        }),
        checkbox = document.createElementWithAttr('INPUT', { type: 'checkbox' }),
        option = document.createElement('OPTION'),
        button = document.createElementWithAttr('BUTTON', { type: 'button' }),
        i,
        j,
        col,
        input,
        form_nodes,
        first_id,
        vals,
        event_args,
        populate_form_args;
    //
    // initializing elements to create form from meta data
    document.getElementById('content-header').textContent = 'Updating Table: ' +
        table_name;
    document.getElementById('content-div').removeAll();
    fieldset.style.width = '65rem';
    legend.textContent = 'Table Row Values';
    //
    fieldset.appendChild(legend);
    form.appendChild(fieldset);
    document.getElementById('content-div').safeAppendChild(form);
    //
    checkbox.style.verticalAlign = 'top';
    skip_label.textContent = 'Skip:';
    force_label.textContent = 'Force:';
    for (i = 0; i < meta_data.length; i++) {
        col = meta_data[i];
        if (col.column_type.match('primary')) {
            input = document.createElementWithAttr('INPUT', { type: 'hidden' });
            input.name = col.column_name;
            fieldset.appendChild(input);
            continue;
        }
        //
        label = label.cloneNode();
        input = document.createElementWithAttr('INPUT', {
            style: { width: '20rem' }
        });
        label.textContent = col.display_name + ': ';
        form_nodes = [ label ];
        //
        if (col.column_type.match(/enum/)) {
            vals = col.column_type.match(/enum\[(.*?)\]/);
            vals = vals[1].split(',');
            input = document.createElement('SELECT');
            //
            for (j = 0; j < vals.length; j++) {
                option = option.cloneNode();
                option.textContent = vals[j];
                option.value = vals[j];
                input.appendChild(option);
            }
        } else if (col.data_type.match(/bool/)) {
            input = document.createElement('SELECT');
            //
            option = option.cloneNode();
            option.value = '0';
            option.textContent = 'NO';
            input.appendChild(option);
            //
            option = option.cloneNode();
            option.value = '1';
            option.textContent = 'YES';
            input.appendChild(option);
        } else if (col.data_type.match(/text/)) {
            input = document.createElementWithAttr('TEXTAREA', {
                rows: '4',
                cols: '50'
            });
        }
        input.id = col.column_name.replace(/_/g, '-');
        input.name = col.column_name;
        input.style.marginRight = '1em';
        input.dataset.data_type = col.data_type;
        form_nodes.push(input);
        //
        // adding a skip and force checkbox
        skip_label = skip_label.cloneNode(true);
        checkbox = checkbox.cloneNode();
        checkbox.id = 'skip-' + input.id;
        form_nodes.push(skip_label);
        form_nodes.push(checkbox);
        //
        force_label = force_label.cloneNode(true);
        checkbox = checkbox.cloneNode();
        checkbox.id = 'force-' + input.id;
        form_nodes.push(force_label);
        form_nodes.push(checkbox);
        //
        form_nodes.push(br.cloneNode());
        fieldset.addNodes(form_nodes);
        if (!first_id) {
            first_id = input.id;
        }
    }
    //
    // adding buttons and error message
    label = label.cloneNode();
    label.id = 'form-errors';
    label.textContent = 'Form errors are highlighted in red';
    label.className = 'error-msg hidden-elm';
    //
    button.textContent = 'Submit Form';
    button.addEventListener(
        'click',
        submit_info_table_changes.bind(null, form, table_name)
    );
    //
    document.getElementById('content-div').safeAppendChild(br.cloneNode());
    document.getElementById('content-div').safeAppendChild(label);
    document.getElementById('content-div').safeAppendChild(br.cloneNode());
    document.getElementById('content-div').safeAppendChild(button);
    //
    // adding standard event handlers
    event_args = {
        meta_array: meta_data,
        add_default_events: function(elm) {
            var event = elm.primaryEventString();
            if (elm.nodeName.toLowerCase() === 'button') {
                return;
            }
            if (!event) {
                return;
            }
            //
            elm.addEventListener(
                event,
                AFW_HUB.Utilities.remove_class.bind(null, 'boxshadow-red', elm)
            );
        }
    };
    AFW_HUB.FormUtil.add_standard_event_listeners(form, event_args);
    //
    // populating fields on the form
    populate_form_args = {form: form};
    response.form_data = [row_data];
    AFW_HUB.FormUtil.populate_form(populate_form_args, response);
    document.getElementById(first_id).focus();
}
//
// this fuction excecutes the desired command on the data table
function submit_info_table_changes(form, table_name) {
    //
    var form_values = AFW_HUB.FormUtil.get_all_form_values(form),
        msg = 'Are you sure you want to update table: {}?',
        post_data,
        callback;
    //
    msg = msg.format(table_name);
    if (AFW_HUB.FormUtil.auto_validate(form)) {
        return;
    }
    if (!confirm(msg)) {
        return;
    }
    //
    post_data = {
        method: 'update_misc_table',
        table_name: table_name,
        form_values: JSON.stringify(form_values)
    };
    //
    callback = function(xmlhttp) {
        //
        AFW_HUB.Ajax.process_response(xmlhttp);
        alert('Sucessfully updated table: ' + table_name);
        //
        // regens table and clears elements
        document.getElementById('db-misc-table').dispatchPrimaryEvent();
        document.getElementById('content-header').textContent = '';
        document.getElementById('content-div').removeAll();
    };
    //
    AFW_HUB.Ajax.send_aync_request(post_data, callback);
}
//
///////////////////////////// Column Meta Data Form ///////////////////////////
//
// handles submission of the column meta data form
function submit_col_meta_data_form(form) {
    //
    var errors = AFW_HUB.FormUtil.auto_validate(form),
        form_values = AFW_HUB.FormUtil.get_all_form_values(form),
        cont;
    //
    if (errors) {
        return;
    }
    cont = confirm('Confirm update of column meta data');
    if (!cont) {
        return;
    }
    //
    AFW_HUB.Ajax.submit_form_values(
        form.name,
        form_values,
        reset_column_meta_data_page
    );
}
//
function reset_column_meta_data_page() {
    //
    alert('Successfully updated column meta data');
    //
    // regens table and clears elements
    document.getElementById('col-meta-table').dispatchPrimaryEvent();
    document.getElementById('content-header').textContent = '';
    document.getElementById('content-div').removeAll();
}
//
/////////////////////////////// Form Meta Data Form ///////////////////////////
//
// builds the form data updating table
function build_form_data_entry(form_name, form, response) {
    //
    var content_header = document.getElementById('content-header'),
        content_div = document.getElementById('content-div'),
        sql_args,
        callback,
        meta_data,
        i;
    //
    // loading form meta data entry
    if (form === undefined) {
        callback = build_form_data_entry.bind(null, form_name);
        form = 'form_meta_data_entry';
        AFW_HUB.FormUtil.load_html_form(form, content_div, callback);
        return;
    }
    //
    // setting up sql args and querying response
    if (response === undefined) {
        sql_args = {
            cmd: 'SELECT',
            cols: [
                'column_meta_data.in_database',
                'column_meta_data.in_table',
                'column_meta_data.column_name',
                'column_meta_data.column_type',
                'form_meta_data.*'
            ],
            table: 'column_meta_data',
            inner_join: [
                [
                    'form_meta_data',
                    'column_meta_data.internal_id',
                    'form_meta_data.column_internal_id'
                ]
            ],
            where: [ [ 'form_meta_data.form_name', 'LIKE', form_name ] ],
            order_by: [
                [ 'form_meta_data.submission_order', 'ASC' ],
                [ 'column_meta_data.in_database', 'ASC' ],
                [ 'column_meta_data.in_table', 'ASC' ],
                [ 'column_meta_data.column_name', 'ASC' ]
            ]
        };
        //
        callback = build_form_data_entry.bind(null, form_name, form);
        AFW_HUB.Ajax.fetch_db(
            [ sql_args ],
            [ 'meta_data' ],
            'meta_database',
            callback
        );
        return;
    }
    //
    // initializing elements
    content_header.textContent = 'Updating Meta Data for Form: ' + form_name;
    //
    // processing meta data returned to build form
    meta_data = response.meta_data;
    for (i = 0; i < meta_data.length; i++) {
        add_form_meta_row(null, meta_data[i]);
    }
    //
    // adding submission event handler
    document
        .getElementById('submit-form')
        .addEventListener(
            'click',
            submit_form_meta_data_entries.bind(null, form_name, form)
        );
}
//
// adds a new row to meta data form
function add_form_meta_row(row_id, data) {
    //
    var row = document.getElementById(row_id) || { dataset: null },
        entry_table = document.getElementById('content-div').querySelector('TABLE'),
        update_error_css = AFW_HUB.FormUtil.update_error_css,
        null_onclick = AFW_HUB.FormUtil.null_value,
        cell,
        input,
        elm;
    data = Object.clone(row.dataset) || data;
    //
    // modifying row data
    if (row.dataset) {
        data.column_internal_id = data.internal_id;
        delete data.internal_id;
    }
    //
    // preparing cloned row
    row = document.getElementById('clone-row').cloneNode(true);
    row.id = 'column-id-' + data.column_internal_id;
    // preventing an existing row from being reset by the meta table
    if (document.getElementById(row.id)) {
        return;
    }
    //
    // populating  static cells
    cell = row.querySelector('[data-column_name="in_database"]');
    cell.textContent = data.in_database;
    cell = row.querySelector('[data-column_name="in_table"]');
    cell.textContent = data.in_table;
    cell = row.querySelector('[data-column_name="column_name"]');
    cell.textContent = data.column_name;
    //
    // branching logic for set statements
    if (data.column_type === 'set_statement') {
        // removing population alias cell
        row.querySelector('[name="display_expr"]').parentNode.remove();
        //
        // expanding submission alias cell
        input = row.querySelector('[name="submission_expr"]');
        input.addEventListener('keyup', update_error_css.bind(null, false, input));
        input.cols = 2 * Number(input.cols);
        cell = input.parentNode;
        cell.colSpan = 2;
        cell.style.textAlign = 'center';
        //
        // disabling a unneed inputs
        row.querySelector('[name="submit_value"]').disabled = true;
        row.querySelector('[name="linking_column"]').disabled = true;
        row.querySelector('[name="linking_column_name"]').disabled = true;
    } else {
        //
        // adding null checkboxes
        input = row.querySelector('[name="display_expr"]');
        input.parentNode.addTextNode('NULL: ');
        elm = document.createElementWithAttr('INPUT', { type: 'CHECKBOX' });
        elm.addEventListener('click', null_onclick.bind(null, elm, input));
        input.addEventListener('keyup', update_error_css.bind(null, false, input));
        input.parentNode.appendChild(elm);
        if (!data.display_expr || data.display_expr.toLowerCase() === 'null') {
            elm.checked = true;
            elm.dispatchPrimaryEvent();
        }
        //
        input = row.querySelector('[name="submission_expr"]');
        input.parentNode.addTextNode('NULL: ');
        elm = document.createElementWithAttr('INPUT', { type: 'CHECKBOX' });
        elm.addEventListener('click', null_onclick.bind(null, elm, input));
        input.addEventListener('keyup', update_error_css.bind(null, false, input));
        input.parentNode.appendChild(elm);
        if (!data.submission_expr || data.submission_expr.toLowerCase() === 'null') {
            elm.checked = true;
            elm.dispatchPrimaryEvent();
        }
    }
    //
    // adding "X" to remove the row
    row.appendChild(document.createElement('TD'));
    elm = document.createElementWithAttr('SPAN', { style: { color: 'red' } });
    elm.textContent = 'X';
    elm.title = 'Remove Row';
    elm.addEventListener('click', row.remove.bind(row));
    row.lastChild.appendChild(elm);
    //
    // adding events to toggle validation of linking_column_name if needed
    elm = row.querySelector('[name="linking_column"]');
    elm.addEventListener(
        'change',
        function(linking_inp) {
            linking_inp.dataset.skip_auto_validate = '';
            if (this.value.match(/^null$|^master$/i)) {
                linking_inp.dataset.skip_auto_validate = 1;
                update_error_css(false, linking_inp);
            }
        }.bind(elm, row.querySelector('[name="linking_column_name"]'))
    );
    //
    // outputting row, setting event handlers and populating fields
    entry_table.safeAppendChild(row);
    AFW_HUB.FormUtil.add_standard_event_listeners(row, {});
    AFW_HUB.FormUtil.populate_form({form_id: row.id}, {form_data: [data]});
    //
    // reloading table with specific database if required
    if (document.getElementById('refine-in-database').value === '.*') {
        document.getElementById('refine-in-database').value = '^{}$'.format(
            data.in_database
        );
        document.getElementById('refine-in-database').dispatchPrimaryEvent();
    }
}
//
// validates and submits the form meta data form
function submit_form_meta_data_entries(form_name, form) {
    //
    var errors = AFW_HUB.FormUtil.auto_validate(form),
        rows = form.querySelectorAll('TR'),
        form_values = [],
        i,
        vals,
        master = 0,
        cont;
    //
    // pulling form values from each table row
    for (i = 1; i < rows.length; i++) {
        vals = AFW_HUB.FormUtil.get_all_form_values(rows[i]);
        if (rows[i].dataset.set_statement === 'true') {
            vals.submission_expr = '@{variable_name}={variable_value}'.format(vals);
            delete vals.variable_name;
            delete vals.variable_value;
        }
        if ((vals.linking_column || '').match(/^master$/i)) {
            master += 1;
        }
        vals.form_name = form_name;
        form_values.push(vals);
    }
    //
    if (!master) {
        errors = true;
        alert('Error - no MASTER table defined');
    } else if (master > 1) {
        errors = true;
        alert('Error - Only one MASTER table can be defined');
    }
    //
    if (errors) {
        return;
    }
    cont = confirm('Confirm update of form meta data');
    if (!cont) {
        return;
    }
    //
    send_form_meta_data(form_name, form_values);
}
//
// submits form data to the database
function send_form_meta_data(form_name, form_values, xmlhttp) {
    var post_data, callback, response;
    //
    post_data = {
        method: 'submit_form_meta_data',
        form_name: form_name,
        form_values: JSON.stringify(form_values)
    };
    //
    if (xmlhttp === undefined) {
        callback = send_form_meta_data.bind(null, form_name, form_values);
        AFW_HUB.Ajax.send_aync_request(post_data, callback);
        return;
    }
    //
    response = AFW_HUB.Ajax.process_response(xmlhttp);
    reset_form_meta_data_page(form_name, response);
}
//
// resets the page after sucessful submission of form data
function reset_form_meta_data_page(form_name) {
    //
    alert('Successfully updated meta data for form: ' + form_name);
    //
    // resetting page elements
    AFW_HUB.Utilities.add_class('hidden-elm', 'table-div');
    document.getElementById('toggle-form-meta-table').value = 'update-button';
    document.getElementById('toggle-form-meta-table').dispatchPrimaryEvent();
    document.getElementById('content-header').textContent = '';
    document.getElementById('content-div').removeAll();
}
//
////////////////////////////// Table Meta Data Form ///////////////////////////
//
// adds a new row to meta data form
function add_table_meta_row(row_id, data) {
    //
    var row = document.getElementById(row_id) || { dataset: null },
        entry_table = document.getElementById('content-div').querySelector('TABLE'),
        update_error_css = AFW_HUB.FormUtil.update_error_css,
        null_onclick = AFW_HUB.FormUtil.null_value,
        cell,
        input,
        elm,
        args;
    data = Object.clone(row.dataset) || data;
    //
    // modifying row data
    if (row.dataset) {
        data.column_internal_id = data.internal_id;
        delete data.internal_id;
        delete data.display_expr;
    }
    //
    // preparing cloned row
    row = document.getElementById('clone-row').cloneNode(true);
    row.id = 'column-id-' + data.column_internal_id;
    // preventing an existing row from being reset by the meta table
    if (document.getElementById(row.id)) {
        return;
    }
    Object.merge(row.dataset, data);
    //
    // populating  static cells
    cell = row.querySelector('[data-column_name="in_database"]');
    cell.textContent = data.in_database;
    cell = row.querySelector('[data-column_name="in_table"]');
    cell.textContent = data.in_table;
    cell = row.querySelector('[data-column_name="column_name"]');
    cell.textContent = data.column_name;
    //
    // adding null checkboxes
    input = row.querySelector('[name="display_expr"]');
    input.parentNode.addTextNode('NULL: ');
    elm = document.createElementWithAttr('INPUT', { type: 'CHECKBOX' });
    elm.addEventListener('click', null_onclick.bind(null, elm, input));
    input.addEventListener('keyup', update_error_css.bind(null, false, input));
    input.parentNode.appendChild(elm);
    if (!data.display_expr || data.display_expr.toLowerCase() === 'null') {
        elm.checked = true;
        elm.dispatchPrimaryEvent();
    }
    //
    // adding "X" to remove the row
    row.appendChild(document.createElement('TD'));
    elm = document.createElementWithAttr('SPAN', { style: { color: 'red' } });
    elm.textContent = 'X';
    elm.title = 'Remove Row';
    elm.addEventListener('click', row.remove.bind(row));
    elm.addEventListener('click', function() {
        var disp_table = document.getElementById('table-meta-disp-table');
        disp_table.dispatchPrimaryEvent();
    });
    row.lastChild.appendChild(elm);
    //
    // adding events to toggle validation of linking_column_name if needed
    elm = row.querySelector('[name="linking_column"]');
    elm.addEventListener(
        'change',
        function(linking_inp, usage_inp, pages_inp) {
            linking_inp.dataset.skip_auto_validate = '';
            pages_inp.dataset.skip_auto_validate = '';
            if (this.value.match(/^null$|^master$/i)) {
                linking_inp.dataset.skip_auto_validate = 1;
                update_error_css(false, linking_inp);
            }
            if (this.value.match(/^master$/i) && usage_inp.value.match(/^null$/i)) {
                pages_inp.dataset.skip_auto_validate = 1;
                update_error_css(false, pages_inp);
            }
        }.bind(
            elm,
            row.querySelector('[name="linking_column_name"]'),
            row.querySelector('[name="column_usage"]'),
            row.querySelector('[name="use_on_pages"]')
        )
    );
    //
    // outputting row, setting event handlers and populating fields
    entry_table.safeAppendChild(row);
    args = {
        add_default_events: function(elem) {
            var event = elem.primaryEventString();
            if (elem.nodeName.toLowerCase() === 'button') {
                return;
            }
            if (!event) {
                return;
            }
            //
            elem.addEventListener(
                event,
                AFW_HUB.Utilities.remove_class.bind(null, 'boxshadow-red', elem)
            );
            elem.addEventListener(event, function() {
                var disp_table = document.getElementById('table-meta-disp-table');
                if (disp_table) {
                    disp_table.dispatchPrimaryEvent();
                }
            });
        }
    };
    AFW_HUB.FormUtil.add_standard_event_listeners(row, args);
    //
    args = { form_id: row.id, trigger_events: true };
    AFW_HUB.FormUtil.populate_form(args, {form_data: [data]});
    //
    // reloading table with specific database if required
    if (document.getElementById('refine-in-database').value === '.*') {
        document.getElementById('refine-in-database').value = '^{}$'.format(
            data.in_database
        );
        document.getElementById('refine-in-database').dispatchPrimaryEvent();
    }
    //
    // regenerating display table
    if (document.getElementById('table-meta-disp-table')) {
        document.getElementById('table-meta-disp-table').dispatchPrimaryEvent();
    }
}
//
// validates and submits the table meta data form
function submit_table_meta_data_entries(html_table_name, form) {
    //
    var errors = AFW_HUB.FormUtil.auto_validate(form),
        rows = form.querySelectorAll('TR'),
        form_values = [],
        i,
        row_values,
        master,
        cont;
    //
    // pulling form values from each table row
    master = 0;
    for (i = 1; i < rows.length; i++) {
        row_values = AFW_HUB.FormUtil.get_all_form_values(rows[i]);
        row_values.html_table = html_table_name;
        if ((row_values.linking_column || '').match(/^master$/i)) {
            master += 1;
        }
        form_values.push(row_values);
    }
    //
    if (!master) {
        errors = true;
        alert('Error - no MASTER table defined');
    } else if (master > 1) {
        errors = true;
        alert('Error - Only one MASTER table can be defined');
    }
    //
    if (errors) {
        return;
    }
    cont = confirm('Confirm update of table meta data');
    if (!cont) {
        return;
    }
    //
    send_table_meta_data(html_table_name, form_values);
}
//
// submits form data to the database
function send_table_meta_data(html_table_name, form_values, xmlhttp) {
    var post_data, callback, response;
    //
    post_data = {
        method: 'submit_table_meta_data',
        html_table_name: html_table_name,
        form_values: JSON.stringify(form_values)
    };
    //
    if (xmlhttp === undefined) {
        callback = send_table_meta_data.bind(null, html_table_name, form_values);
        AFW_HUB.Ajax.send_aync_request(post_data, callback);
        return;
    }
    //
    response = AFW_HUB.Ajax.process_response(xmlhttp);
    reset_table_meta_data_page(html_table_name, response);
}
//
// resets the page after sucessful submission of form data
function reset_table_meta_data_page(html_table_name) {
    //
    alert('Successfully updated meta data for table: ' + html_table_name);
    //
    // resetting page elements
    AFW_HUB.Utilities.add_class('hidden-elm', 'meta-table-div');
    AFW_HUB.Utilities.add_class('hidden-elm', 'disp-table-div');
    document.getElementById('toggle-table-meta-table').value = 'update-button';
    document.getElementById('toggle-table-meta-table').dispatchPrimaryEvent();
    document.getElementById('toggle-display-table').value = 'update-button';
    document.getElementById('toggle-display-table').dispatchPrimaryEvent();
    document.getElementById('content-header').textContent = '';
    document.getElementById('content-div').removeAll();
}
//
////////////////////////////// Table Preset Form //////////////////////////////
//
// clones a row and adds it to the form
function clone_entry_div(entry_name) {
    var entry_div = document.querySelector('[name="' + entry_name + '-clone"]'),
        sep_br = document.getElementById(entry_name + '-bottom'),
        div = entry_div.cloneNode(true),
        br = document.createElement('BR'),
        rem_span = document.createElement('SPAN'),
        args = {
            add_default_events: function(elm) {
                var event = elm.primaryEventString();
                var remove_class = AFW_HUB.Utilities.remove_class;
                if (elm.nodeName.toLowerCase() === 'button') {
                    return;
                }
                if (!event) {
                    return;
                }
                remove_class = remove_class.bind(null, 'boxshadow-red', elm);
                elm.addEventListener(event, remove_class);
            }
        };
    div.setAttribute('name', entry_name);
    //
    rem_span.style.color = 'red';
    rem_span.style.marginLeft = '1em';
    rem_span.textContent = 'X';
    rem_span.addEventListener('click', div.remove.bind(div));
    //
    div.appendChild(rem_span);
    div.appendChild(br);
    sep_br.parentNode.insertBefore(div, sep_br);
    AFW_HUB.FormUtil.add_standard_event_listeners(div, args);
    //
    return div;
}
//
// processes the JSON data to build the form
function build_preset_table_form(form, form_response, response) {
    var form_args = {
            form_id: form.id,
            trigger_events: false,
            sql_args: {},
            add_callback: function() {}
        },
        form_data = form_response.form_data[0],
        sql_args = form_data.sql_args_json || '{}',
        args,
        callback,
        div,
        i;
    sql_args = JSON.parse(sql_args);
    //
    // fetching columns first if this is an existing preset
    if (form_data.html_table && response === undefined) {
        callback = build_preset_table_form.bind(null, form, form_response);
        args = [form_data.html_table, {meta_data_only: 1, page: '.+'}, callback];
        AFW_HUB.TableUtil.fetch_table_data.apply(null, args);
        return;
    }
    //
    // setting up columns
    build_preset_column_checkboxes(response.meta_data, sql_args);
    //
    // building where aspect of the form
    sql_args.where = sql_args.where || [];
    for (i = 0; i < sql_args.where.length; i++) {
        div = clone_entry_div('where-clause');
        form_data = [
            {
                column: sql_args.where[i][0],
                type: sql_args.where[i][1],
                condition: sql_args.where[i][2]
            }
        ];
        // I need an ID until I refactor the populate form functions
        //div.id = Math.floor(Math.random() * 1000000000);
        form_args.form = div;//.id;
        AFW_HUB.FormUtil.populate_form(form_args, {form_data: form_data});
    }
    //
    if (document.getElementById('group-by').value === '') {
        document.getElementById('null-group-by').checked = true;
        document.getElementById('null-group-by').dispatchPrimaryEvent();
    }
    if (document.getElementById('having').value === '') {
        document.getElementById('null-having').checked = true;
        document.getElementById('null-having').dispatchPrimaryEvent();
    }
}
//
// sets up the column name checkboxes for the presets form
function build_preset_column_checkboxes(column_data, sql_args) {
    var col_div = document.getElementById('columns'),
        all_columns = document.getElementById('all-columns'),
        label = document.createElement('LABEL'),
        checkbox = document.createElementWithAttr('INPUT', { type: 'checkbox' }),
        br = document.createElement('BR'),
        checkboxes = [],
        i;
    sql_args.cols = sql_args.cols || [];
    label.style.width = '20em';
    checkbox.style.marginRight = '1em';
    //
    for (i = 0; i < column_data.length; i++) {
        //
        label = label.cloneNode();
        label.textContent = column_data[i].display_name;
        checkbox = checkbox.cloneNode();
        checkbox.checked = false;
        checkbox.dataset.column_name = column_data[i].db_table_col;
        if (sql_args.cols.indexOf(column_data[i].db_table_col) > -1) {
            checkbox.checked = true;
        }
        checkboxes.push(checkbox);
        col_div.addNodes([ checkbox, label ]);
        //
        if ((i + 1) % 2 === 0) {
            col_div.appendChild(br.cloneNode());
        }
    }
    //
    // checking all-columns if none provided
    all_columns.addEventListener('click', function() {
        checkboxes.forEach(function(cb) {
            cb.disabled = all_columns.checked;
        });
    });
    if (sql_args.cols.length === 0) {
        all_columns.checked = true;
        all_columns.dispatchPrimaryEvent();
    }
}
//
// clears the preset SQL args fieldset
function reset_preset_sql_args() {
    var fieldset = document.getElementById('sql-args'),
        where_clauses = fieldset.querySelectorAll('[name="where-clause"]'),
        i;
    //
    // resetting the sql args form
    document.getElementById('columns').removeAll();
    document.getElementById('group-by').value = '';
    document.getElementById('null-group-by').checked = false;
    document.getElementById('null-group-by').dispatchPrimaryEvent();
    document.getElementById('having').value = '';
    document.getElementById('null-having').checked = false;
    document.getElementById('null-having').dispatchPrimaryEvent();
    //
    for (i = 0; i < where_clauses.length; i++) {
        where_clauses[i].remove();
    }
}
//
// processes the sql args fieldset and generate an argument object
function process_sql_args_fieldset() {
    var fieldset = document.getElementById('sql-args'),
        col_div = document.getElementById('columns'),
        columns = col_div.querySelectorAll(':checked'),
        where_clauses = fieldset.querySelectorAll('[name="where-clause"]'),
        form_values = AFW_HUB.FormUtil.get_all_form_values(fieldset),
        sql_args = {
            cols: [],
            where: [],
            group_by: form_values.group_by,
            having: form_values.having
        },
        clause,
        i;
    // adding columns
    for (i = 0; i < columns.length; i++) {
        sql_args.cols[i] = columns[i].dataset.column_name;
    }
    if (document.getElementById('all-columns').checked) {
        delete sql_args.cols;
    }
    // adding where clauses
    for (i = 0; i < where_clauses.length; i++) {
        form_values = AFW_HUB.FormUtil.get_all_form_values(where_clauses[i]);
        clause = [ form_values.column, form_values.type ];
        if (form_values.condition) {
            clause.push(form_values.condition);
        }
        sql_args.where[i] = clause;
    }
    //
    return sql_args;
}
//
// submits the preset form to the database
function submit_preset_form_data(form) {
    var errors = AFW_HUB.FormUtil.auto_validate(form),
        form_values = AFW_HUB.FormUtil.get_all_form_values(form),
        sql_args = process_sql_args_fieldset(),
        cont;
    //
    if (errors) {
        return;
    }
    cont = confirm('Confirm update of column meta data');
    if (!cont) {
        return;
    }
    //
    form_values = {
        preset_name: form_values.preset_name,
        html_table: form_values.html_table,
        use_on_pages: form_values.use_on_pages,
        sql_args_json: JSON.stringify(sql_args),
        internal_id: form_values.internal_id
    };
    AFW_HUB.Ajax.submit_form_values(form.name, form_values, reset_table_preset_page);
}
//
// resets the preset form after submission
function reset_table_preset_page() {
    //
    alert('Successfully updated table preset data');
    //
    // regens table and clears elements
    document.getElementById('presets-table').dispatchPrimaryEvent();
    document.getElementById('content-header').textContent = '';
    document.getElementById('content-div').removeAll();
}
